<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">


<xsl:template name="content_calendar">
  <xsl:param name="content" select="/page/content/topic"/>
  <xsl:choose>
  <xsl:when test="$content/calendar/dategroup">
    <div class="contentTopic">
      <h1>
        Kalender: 
        <xsl:choose>
          <xsl:when test="$content/calendar/dategroup/@mode = 'month'">
            <xsl:call-template name="calendar_monthname">
              <xsl:with-param name="month" select="$content/calendar/dategroup/date-selected/@month"/>
            </xsl:call-template>
            <xsl:call-template name="space"/>
            <xsl:value-of select="$content/calendar/dategroup/date-selected/@year"/>
          </xsl:when>
          <xsl:when test="$content/calendar/dategroup/@mode = 'wday'">
            <xsl:call-template name="calendar_wdayname">
              <xsl:with-param name="wday" select="$content/calendar/dategroup/date-selected/@wday"/>
            </xsl:call-template>s, 
            <xsl:call-template name="calendar_monthname">
              <xsl:with-param name="month" select="$content/calendar/dategroup/date-selected/@month"/>
            </xsl:call-template>
            <xsl:call-template name="space"/>
            <xsl:value-of select="$content/calendar/dategroup/date-selected/@year"/>
          </xsl:when>
          <xsl:when test="$content/calendar/dategroup/@mode = 'day'">
            <xsl:call-template name="calendar_wdayname">
              <xsl:with-param name="wday" select="$content/calendar/dategroup/date-selected/@wday"/>
            </xsl:call-template>, 
            <xsl:value-of select="$content/calendar/dategroup/date-selected/@day"/>.
            <xsl:call-template name="calendar_monthname">
              <xsl:with-param name="month" select="$content/calendar/dategroup/date-selected/@month"/>
            </xsl:call-template>
            <xsl:call-template name="space"/>
            <xsl:value-of select="$content/calendar/dategroup/date-selected/@year"/>
          </xsl:when>
          <xsl:when test="$content/calendar/dategroup/@mode = 'week'">
            <xsl:value-of select="$content/calendar/dategroup/date-from/@day"/>.
            <xsl:call-template name="calendar_monthname">
              <xsl:with-param name="month" select="$content/calendar/dategroup/date-from/@month"/>
            </xsl:call-template>
            <xsl:call-template name="space"/>
            <xsl:value-of select="$content/calendar/dategroup/date-from/@year"/>
            -
            <xsl:value-of select="$content/calendar/dategroup/date-to/@day"/>.
            <xsl:call-template name="calendar_monthname">
              <xsl:with-param name="month" select="$content/calendar/dategroup/date-to/@month"/>
            </xsl:call-template>
            <xsl:call-template name="space"/>
            <xsl:value-of select="$content/calendar/dategroup/date-to/@year"/>
          </xsl:when>
        </xsl:choose>
      </h1>
      
  	  <xsl:if test="($content/text/text() != '') or ($content/text/*)">
        <div class="contentText">
          <xsl:apply-templates select="$content/text"/>
        </div>
      </xsl:if>
    </div>
    <xsl:call-template name="calendar_topic">
      <xsl:with-param name="topics" select="$content/calendar/dategroup/date"/>
    </xsl:call-template>
  </xsl:when>
  <xsl:when test="$content/calendar/date">
    <div class="contentTopic">
      <h1>
        <xsl:value-of select="$content/calendar/date/datetitle" disable-output-escaping="yes" />
        <span class="contentSubtitle"><xsl:value-of select="$content/calendar/date/datestr" disable-output-escaping="yes" /></span>
      </h1>
      <div class="contentText">
        <xsl:value-of select="$content/calendar/date/datedetail" disable-output-escaping="yes" />
      </div>
    </div>
  </xsl:when>
  <xsl:otherwise>
    <div class="contentTopic">
      <h1>Kalender</h1>
      <div class="contentText">
        Keine Termine im ausgew&#xE4;hlten Zeitraum gefunden.
      </div>
    </div>
  </xsl:otherwise>
</xsl:choose>
</xsl:template>



<xsl:template name="calendar_monthname">
  <xsl:param name="month"/>
  <xsl:choose>
    <xsl:when test="$month=1">Januar</xsl:when>
    <xsl:when test="$month=2">Februar</xsl:when>
    <xsl:when test="$month=3">M&#xE4;rz</xsl:when>
    <xsl:when test="$month=4">April</xsl:when>
    <xsl:when test="$month=5">Mai</xsl:when>
    <xsl:when test="$month=6">Juni</xsl:when>
    <xsl:when test="$month=7">Juli</xsl:when>
    <xsl:when test="$month=8">August</xsl:when>
    <xsl:when test="$month=9">September</xsl:when>
    <xsl:when test="$month=10">Oktober</xsl:when>
    <xsl:when test="$month=11">November</xsl:when>
    <xsl:when test="$month=12">Dezember</xsl:when>
  </xsl:choose>  
</xsl:template>

<xsl:template name="calendar_wdayname">
  <xsl:param name="wday"/>
  <xsl:choose>
    <xsl:when test="$wday=1">Montag</xsl:when>
    <xsl:when test="$wday=2">Dienstag</xsl:when>
    <xsl:when test="$wday=3">Mittwoch</xsl:when>
    <xsl:when test="$wday=4">Donnerstag</xsl:when>
    <xsl:when test="$wday=5">Freitag</xsl:when>
    <xsl:when test="$wday=6">Samstag</xsl:when>
    <xsl:when test="$wday=7">Sonntag</xsl:when>
  </xsl:choose>  
</xsl:template>

<xsl:template name="calendar_topic">
  <xsl:param name="topics" />
  <xsl:variable name="topicscount" select="count($topics)" />
  <xsl:variable name="topicslinecount">2</xsl:variable>

    <xsl:for-each select="$topics[(position() mod $topicslinecount) =1]">
      <xsl:variable name="indexmin" select="position() * $topicslinecount - $topicslinecount" />
      <xsl:variable name="indexmax" select="position() * $topicslinecount" />
      <xsl:call-template name="topic_link">
        <xsl:with-param name="topics" 
          select="$topics[((position() &gt; $indexmin) and (position() &lt;= $indexmax))]"/>
        <xsl:with-param name="topicscount" select="$topicscount" />
        <xsl:with-param name="topicslinecount" select="$topicslinecount"/>
      </xsl:call-template>
    </xsl:for-each>
</xsl:template>

<xsl:template name="topic_link">
  <xsl:param name="topics" />
  <xsl:param name="topicscount"/>
  <xsl:param name="topicslinecount"/>
  <xsl:param name="count" select="count($topics)" />
  <xsl:param name="width" select="round(100 div $topicslinecount)"/>
  <div class="subTopicLine">
    <xsl:choose>
      <xsl:when test="$count &gt; 1">
        <table border="0" class="calendarDates">  
          <tr>
            <xsl:for-each select="$topics">   
              <xsl:variable name="swidth">
                <xsl:choose>
                  <xsl:when test="($topicslinecount &gt; $count) and (position() = $count)">
                    <xsl:value-of select="0" />
                  </xsl:when>
                  <xsl:when test="position() != $topicslinecount">
                    <xsl:value-of select="$width" />
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="( 100 - ( $width * ( $topicslinecount - 1 ) ) )" />
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:variable>    
              <td class="calendarDate"> 
                <xsl:if test="$swidth &gt; 0">
                  <xsl:attribute name="width"><xsl:value-of select="$swidth"/>%</xsl:attribute>
                </xsl:if>
                <div class="title">
                  <h2><xsl:value-of select="datestr" /></h2>
                  <h3><xsl:value-of select="datetitle/a" /></h3>
                </div>
                <div class="contentTeaser"><xsl:value-of select="datedetail/text" /></div>
                
              </td>
            </xsl:for-each>
          </tr>
        </table>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="topic" select="$topics[position() = 1]"/>
        <div class="calendarDate">   
                <div class="title">
                  <h2><xsl:value-of select="datestr" /></h2>
                  <h3><xsl:value-of select="datetitle/a" /></h3>
                </div>
          <div class="contentTeaser"><xsl:value-of select="datedetail/text" /></div>
        </div>
      </xsl:otherwise>
    </xsl:choose> 
  </div> 
</xsl:template>

</xsl:stylesheet>
