<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template name="content_download">
  <xsl:param name="content" select="/page/content/topic"/>
  <xsl:call-template name="content_topic"/>
  <xsl:if test="$content/file">
    <div class="mediaDownloadDetails">  
      <h2>
        <xsl:value-of select="$content/file/@file_title" disable-output-escaping="yes"/>
        <div class="subTitle">
          <xsl:value-of select="$content/file/@file_date" disable-output-escaping="yes"/>        
        </div>
      </h2>
      <div class="description">
        <xsl:value-of select="$content/file[./text()]" disable-output-escaping="yes"/>
        <a class="downloadButton" href="{$content/file/@download}">
          <xsl:value-of select="$content/file/@file_name" disable-output-escaping="yes"/>
          ( <xsl:value-of select="$content/file/@file_size" disable-output-escaping="yes"/> )
        </a>
        <br clear="all" class="clear" />
      </div>
    </div>
  </xsl:if>
  
  <xsl:if test="count($content/files/file) &gt; 0">
    <h2 class="mediaDownloadAllFilesTitle">Dateien</h2>
    <table class="mediaDownloadAllFiles" border="0">
      <colgroup>
        <col class="title" />
        <col />
        <col />
        <col />
      </colgroup>
      <tr>
        <th class="title">Name</th>
        <th class="filesize">Gr&#xF6;&#xDF;e</th>
        <th class="filedata">Datum</th>
        <th></th>
      </tr>
      <xsl:for-each select="$content/files/file">  
        <tr>
          <xsl:attribute name="class">
            <xsl:choose>
              <xsl:when test="not(position() mod 2)">low</xsl:when>
              <xsl:otherwise>high</xsl:otherwise>
            </xsl:choose>
          </xsl:attribute>
          <td class="title">
            <a href="{@href}">
              <xsl:choose>
                <xsl:when test="@file_title != ''">
                  <xsl:value-of select="@file_title" disable-output-escaping="yes"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="@file_name" disable-output-escaping="yes"/>
                </xsl:otherwise>
              </xsl:choose>
            </a>
          </td>
          <td class="filesize">
              <xsl:value-of select="@file_size" disable-output-escaping="yes"/>
          </td>
          <td>
            <xsl:value-of select="@file_date" disable-output-escaping="yes"/>
          </td>
          <td class="dlButton">
            <a href="{@download}">
              <img border="0" src="{$PAGE_THEME_PATH}pics/dl_button.gif" />
            </a>
          </td>
        </tr>
      </xsl:for-each>
    </table>
  </xsl:if>   
</xsl:template>
</xsl:stylesheet>