<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template name="content_showuser">
  <xsl:variable name="content" select="/page/content/topic"/>
  <xsl:variable name="userdata" select="$content/userdata"/>
  <xsl:if test="$userdata/message">
    <div>
      <xsl:value-of select="$userdata/message" />
    </div>
    <br />
  </xsl:if> 
  <xsl:if test="$userdata/@id">
    <div class="headline">Benutzerdaten</div>
    <table border="0" cellpadding="0" cellspacing="0" width="100%" class="bgMediumGray">
      <tr>
        <td class="persdatacaption">Benutzername: </td>
        <td class="persdata"><xsl:value-of select="$userdata/name" /></td>
      </tr>
      <tr>
        <td class="persdatacaption">Benutzergruppe: </td>
        <td class="persdata"><xsl:value-of select="$userdata/group" /></td>
      </tr>
      <tr>
        <td class="persdatacaption">E-Mail: </td>
        <td class="persdata"><a href="{$userdata/email/@href}"><xsl:value-of select="$userdata/email" /></a></td>
      </tr>
      <xsl:if test="$userdata/email_alt">
        <tr>
          <td class="persdatacaption">E-Mail alternativ: </td>
          <td class="persdata"><a href="{$userdata/email_alt/@href}"><xsl:value-of select="$userdata/email_alt" /></a></td>
        </tr>
      </xsl:if>
      <tr>
        <td class="persdatacaption">Telefon: </td>
        <td class="persdata"><xsl:value-of select="$userdata/phone" /></td>
      </tr>
      <xsl:if test="$userdata/phone_alt">
        <tr>
          <td class="persdatacaption">Telefon alternativ: </td>
          <td class="persdata"><xsl:value-of select="$userdata/phone_alt" /></td>
        </tr>
      </xsl:if>
    </table>
     <xsl:if test="$userdata/dialog"> 
      <form action="{$userdata/dialog/@action}" method="post" style="margin-top: 30px;">
        <xsl:copy-of select="$userdata/dialog/input[@type='hidden']"/>
          <div class="headline">Nachricht schicken</div>
          <table border="0" cellpadding="3" cellspacing="0" width="100%" class="bgMediumGray">
            <xsl:call-template name="profile_input">
              <xsl:with-param name="caption">Betreff</xsl:with-param>
              <xsl:with-param name="line" select="$userdata/dialog/lines/line[@fid='subject']"/>
            </xsl:call-template>
            <xsl:call-template name="profile_input">
              <xsl:with-param name="caption">Nachricht</xsl:with-param>
              <xsl:with-param name="line" select="$userdata/dialog/lines/line[@fid='text']"/>
            </xsl:call-template>
            <tr class="bgWhite">
              <td colspan="2" style="text-align: right; padding-top: 20px;">
                <input type="image" alt="Senden" src="{$PAGE_THEME_PATH}pics/btns/btna_send.gif" />
              </td>
            </tr>
          </table>
      </form>
    </xsl:if>
  </xsl:if>
</xsl:template>


</xsl:stylesheet>