<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml">


<xsl:template name="content_feedback">
  <xsl:param name="content" select="/page/content/topic"/>
  <h1><xsl:value-of select="$content/title"/></h1>

  <xsl:if test="$content/mail/subtopic/title != ''">
    <h2><xsl:value-of select="$content/mail/subtopic/title"/></h2>
  </xsl:if>

  <xsl:if test="$content/text/text()|$content/mail/subtopic/text/*">
    <xsl:copy-of select="$content/text/text()|$content/text/*"/>
  </xsl:if>
  <xsl:if test="$content/mail/message">
    <p>
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="$content/mail/message/@type = 'error'">error</xsl:when>
          <xsl:when test="$content/mail/message/@type = 'warning'">warning</xsl:when>
          <xsl:otherwise>text</xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:apply-templates select="$content/mail/message/*|$content/mail/message/text()"/>
    </p>
  </xsl:if>
  <xsl:if test="$content/mail/form">
    <form class="mail">
      <xsl:copy-of select="$content/mail/form/@*" />
      <xsl:apply-templates select="$content/mail/form/input[@type='hidden']"/>

      <xsl:apply-templates select="$content/mail/form/label[@for='mail[mail_name]']"/>
      <input class="text">
        <xsl:copy-of select="$content/mail/form/input[@name='mail[mail_name]']/@*"/>
      </input>

      <xsl:apply-templates select="$content/mail/form/label[@for='mail[mail_from]']"/>
      <input class="text">
        <xsl:copy-of select="$content/mail/form/input[@name='mail[mail_from]']/@*"/>
      </input>

      <xsl:apply-templates select="$content/mail/form/label[@for='mail[mail_subject]']"/>
      <input class="text">
        <xsl:copy-of select="$content/mail/form/input[@name='mail[mail_subject]']/@*"/>
      </input>

      <xsl:apply-templates select="$content/mail/form/label[@for='mail[mail_message]']"/>
      <textarea class="text">
        <xsl:copy-of select="$content/mail/form/textarea[@name='mail[mail_message]']/@*"/>
        <xsl:text> </xsl:text>
      </textarea>

      <div class="button">
        <input type="submit" class="submitButton" value="Nachricht abschicken"/>
      </div>
    </form>
    <br clear="all" />
  </xsl:if>
</xsl:template>

</xsl:stylesheet>