<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml">

<xsl:template name="content_profile">
  <xsl:variable name="content" select="/page/content/topic"/>
  <xsl:variable name="userdata" select="/page/content/topic/userdata"/>

    <xsl:if test="$userdata/message">
    <div class="userProfi">
      <xsl:value-of select="$userdata/message" />
    </div>
  </xsl:if> 
  <xsl:if test="$userdata/dialog"> 
    <h1>Benutzerprofil</h1>
    <form action="{$userdata/dialog/@action}" method="post">
      <xsl:copy-of select="$userdata/dialog/input[@type='hidden']"/>
      <table class="userProfile" border="0">
      <tr>
        <td class="title">
          Benutzername:
        </td>
        <td class="input">
          <input type="text" value="{$userdata/dialog/lines/line[@fid='surfer_handle']/input/@value}" class="persdata" disabled="disabled" />
          </td>
        </tr>
        <tr>
          <td class="title">
            Personengruppe:
          </td>
          <td class="input">
            <input type="text" value="{$userdata/dialog/lines/line[@fid='surfergroup_title']/input/@value}" class="persdata" disabled="disabled" />
          </td>
        </tr>
        <xsl:call-template name="profile_input">
          <xsl:with-param name="caption">Vorname</xsl:with-param>
          <xsl:with-param name="line" select="$userdata/dialog/lines/line[@fid='surfer_givenname']"/>
        </xsl:call-template>
        <xsl:call-template name="profile_input">
          <xsl:with-param name="caption">Nachname</xsl:with-param>
          <xsl:with-param name="line" select="$userdata/dialog/lines/line[@fid='surfer_surname']"/>
        </xsl:call-template>
        <xsl:call-template name="profile_input">
          <xsl:with-param name="caption">Telefon</xsl:with-param>
          <xsl:with-param name="line" select="$userdata/dialog/lines/line[@fid='surfer_phone_1']"/>
        </xsl:call-template>
        <xsl:call-template name="profile_input">
          <xsl:with-param name="caption">Alternative Tel-Nr.</xsl:with-param>
          <xsl:with-param name="line" select="$userdata/dialog/lines/line[@fid='surfer_phone_2']"/>
        </xsl:call-template>
        <xsl:call-template name="profile_input">
          <xsl:with-param name="caption">E-Mail</xsl:with-param>
          <xsl:with-param name="line" select="$userdata/dialog/lines/line[@fid='surfer_email_1']"/>
        </xsl:call-template>
        <xsl:call-template name="profile_input">
          <xsl:with-param name="caption">Alternative E-Mail</xsl:with-param>
          <xsl:with-param name="line" select="$userdata/dialog/lines/line[@fid='surfer_email_2']"/>
        </xsl:call-template>
        <tr>
          <td class="description" colspan="2">
            <div>
              Wenn Sie Ihr Kennwort &#xE4;ndern m&#xF6;chten, 
              geben Sie bitte das neue Kennwort in den folgenden beiden Feldern ein. 
            </div>
            <div>
              Wenn Sie Ihr Kennwort beibehalten m&#xF6;chten, lassen Sie diese Felder 
              bitte frei.
            </div>
          </td>
        </tr>       
        <xsl:call-template name="profile_input">
          <xsl:with-param name="caption">Neues Kennwort</xsl:with-param>
          <xsl:with-param name="line" select="$userdata/dialog/lines/line[@fid='surfer_password_1']"/>
          <xsl:with-param name="type">password</xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="profile_input">
          <xsl:with-param name="caption">Neues Kennwort best&#xE4;tigen</xsl:with-param>
          <xsl:with-param name="line" select="$userdata/dialog/lines/line[@fid='surfer_password_2']"/>
          <xsl:with-param name="type">password</xsl:with-param>
        </xsl:call-template>
        <tr>
          <td  class="description" colspan="2">
            Bei jeder &#xC4;nderung an Ihren Benutzerdaten m&#xFC;ssen Sie zur 
            Best&#xE4;tigung Ihr aktuelles Kennwort angeben.
          </td>
        </tr>
        <xsl:call-template name="profile_input">
          <xsl:with-param name="caption">Kennwort</xsl:with-param>
          <xsl:with-param name="line" select="$userdata/dialog/lines/line[@fid='surfer_old_password']"/>
          <xsl:with-param name="type">password</xsl:with-param>
        </xsl:call-template>
      </table>
      <input class="userProfileSubmitButton" type="submit" value="Speichern" />
      <a class="userProfileCancelButton" href="{$userdata/dialog/@action}">Abbrechen</a>
    </form>
    <br clear="all" />
  </xsl:if>
</xsl:template>

<xsl:template name="profile_input">
  <xsl:param name="caption"/>
  <xsl:param name="line"/>
  <xsl:param name="type">input</xsl:param>
  <xsl:variable name="error">
    <xsl:choose>
      <xsl:when test="$line/@error">_error</xsl:when>
      <xsl:otherwise></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <tr>
    <td class="title">
      <xsl:choose>
        <xsl:when test="$line/@error">
          <span style="color: #F00; font-weight: bold">
            <xsl:value-of select="$caption" />:</span>
        </xsl:when>
        <xsl:otherwise><xsl:value-of select="$caption" />:</xsl:otherwise>
      </xsl:choose>
    </td>
    <td class="input">
      <xsl:choose>
        <xsl:when test="$line/textarea">
          <textarea name="{$line/textarea/@name}" class="persdata{$error}" cols="30" rows="10">
            <xsl:value-of select="$line/textarea" disable-output-escaping="yes" />
          </textarea>
        </xsl:when>
        <xsl:when test="$type = 'password'">
          <input type="password" value="{$line/input/@value}" name="{$line/input/@name}" maxlength="60" class="persdata{$error}"/>
        </xsl:when>
        <xsl:otherwise>
          <input type="input" value="{$line/input/@value}" name="{$line/input/@name}" maxlength="60" class="persdata{$error}"/>
        </xsl:otherwise>
      </xsl:choose>
    </td>
  </tr>
</xsl:template>

</xsl:stylesheet>