<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml">
  <xsl:template name="content_projects">
    <xsl:param name="content" select="/page/content/topic" />
    <xsl:if test="$content/title != ''">
      <h1>
        <xsl:value-of select="$content/title" />
      </h1>
    </xsl:if>
    <xsl:if test="$content/subtitle != ''">
      <h2>
        <xsl:value-of select="$content/subtitle" />
      </h2>
    </xsl:if>
    <xsl:if test="$content/text != ''">
      <div class="projectsText">
        <xsl:apply-templates select="$content/text" />
      </div>
    </xsl:if>
    <xsl:if test="$content/projects">
      <xsl:call-template name="content_get_projects">
        <xsl:with-param name="projects" select="$content/projects" />
        <xsl:with-param name="staff" select="$content/surfers" />
      </xsl:call-template>  
    </xsl:if>
  </xsl:template>

  <xsl:template name="content_get_projects">
    <xsl:param name="projects" />
    <xsl:param name="staff" />
      <xsl:variable name="projectscount" select="count($projects/project)" />
    <table class="projectTable">
      <tr class="caption">
        <th>&#xAB;Projekt&#xBB;</th>
        <th>Kunde</th>
        <xsl:for-each select="$staff/surfer" >
          <th title="{@fullname}">
            <a href="{@href}"><xsl:value-of select="@login" /></a>
          </th>
        </xsl:for-each>
        <th>Deadline</th>
      </tr>
      <xsl:for-each select="$projects/project">
        <tr>
          <th class="projectTitle"><xsl:value-of select="@title"/></th>
          <td><xsl:value-of select="@customer"/></td>
          <xsl:variable name="project" select="."/>
          <xsl:for-each select="$staff/surfer">
            <xsl:variable name="surferlogin" select="@login"/>
            
            <td>
              <xsl:attribute name="class">
                <xsl:choose>
                  <xsl:when test="not(position() mod 2)">low</xsl:when>
                  <xsl:otherwise>high</xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>              
              <xsl:choose>
                <xsl:when test="count($project/surfers/surfer[@title = $surferlogin]) &gt; 0">X</xsl:when>
                <xsl:otherwise><xsl:call-template name="space"/></xsl:otherwise>
              </xsl:choose>
            </td>
          
          </xsl:for-each>
          <td><xsl:value-of select="$project/@deadline" /></td>
        </tr>
      </xsl:for-each>
    </table>
  </xsl:template>

</xsl:stylesheet>

