<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://www.w3.org/1999/xhtml">

<xsl:template name="content_topic">
  <xsl:param name="content" select="/page/content/topic"/>
  <h1 class="contentTitle">
    <xsl:choose>
      <xsl:when test="$content/title/text() != ''"><xsl:value-of select="$content/title" disable-output-escaping="yes"/></xsl:when>
      <xsl:otherwise><xsl:value-of select="$PAGE_TITLE" disable-output-escaping="yes"/></xsl:otherwise>
    </xsl:choose>
    <xsl:if test="$content/subtitle/text() != ''">
      <span class="contentSubtitle"><xsl:value-of select="$content/subtitle" disable-output-escaping="yes"/></span>
    </xsl:if>   
  </h1>
  <xsl:if test="$content/text/text() or $content/text/*">
    <div class="contentText">
      <xsl:choose>
        <xsl:when test="$content/image[((@align='left') and (@break='none'))]//img">
          <div class="topicImageLeftBreakNone">
            <xsl:apply-templates select="$content/image//img"/>
          </div>
        </xsl:when>
        <xsl:when test="$content/image[((@align='right') and (@break='none'))]//img">
          <div class="topicImageRightBreakNone">
            <xsl:apply-templates select="$content/image//img"/>
          </div>
        </xsl:when>
        <xsl:when test="$content/image[((@align='left') and (@break='side'))]//img">
          <div class="topicImageLeftBreakSide">
            <xsl:apply-templates select="$content/image//img"/>
          </div>
        </xsl:when>
        <xsl:when test="$content/image[((@align='right') and (@break='side'))]//img">
          <div class="topicImageRightBreakSide">
            <xsl:apply-templates select="$content/image//img"/>
          </div>
        </xsl:when>
        <xsl:when test="$content/image[@break='center']//img">
          <div class="topicImageCenter">
            <xsl:apply-templates select="$content/image//img"/>
          </div>
        </xsl:when>
      </xsl:choose>
      <div class="topicText">
        <xsl:apply-templates select="$content/text"/>
      </div>  
      <div class="clear" />
    </div>    
  </xsl:if>
</xsl:template>

</xsl:stylesheet>