<?xml version="1.0"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:import href="./lang/language.xsl" />
<xsl:import href="./lang/de.xsl"/>
<xsl:import href="./lang/en.xsl"/>

<xsl:output method="xml" encoding="utf-8" standalone="yes" indent="yes" />

<xsl:param name="PAGE_WEB_PATH">/</xsl:param>
<xsl:param name="PAGE_BASE_URL"></xsl:param>
<xsl:param name="PAGE_TITLE"></xsl:param>

<xsl:variable name="TIME_OFFSET">+01:00</xsl:variable>

<xsl:template match="/">
  <feed xmlns="http://www.w3.org/2005/Atom">
    <xsl:attribute name="xml:lang"><xsl:value-of select="substring($PAGE_LANGUAGE, 0, 3)" /></xsl:attribute>
    <title>papaya 5 Demo</title>
    <link href="{$PAGE_BASE_URL}"/>
    <updated><xsl:value-of select="/page/content/topic/@published" /></updated>
    <author>
      <name>Author</name>
    </author>
    <subtitle>papaya 5 Atom Feed</subtitle>
    <id><xsl:value-of select="$PAGE_BASE_URL"/></id>

    <xsl:for-each select="/page/content/topic/subtopics/subtopic">
      <entry>
        <title><xsl:value-of select="title" /></title>
        <link href="{$PAGE_BASE_URL}{@href}"/>
        <id><xsl:value-of select="$PAGE_BASE_URL"/><xsl:value-of select="@href" /></id>
        <updated><xsl:value-of select="substring(@published, 0, 11)" />T<xsl:value-of select="substring(@published, 12, 10)" /><xsl:value-of select="$TIME_OFFSET"/></updated>
        <summary><xsl:value-of select="subtitle" /> - <xsl:value-of select="text" /></summary>
      </entry>
    </xsl:for-each>
  </feed>
</xsl:template>

</xsl:stylesheet>