<?php
/**
* Page module link with teaser.
*
* @package module_default
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: content_teaserlink.php,v 1.6 2006/02/08 14:20:24 weinert Exp $
*/

/**
* Basic class page module
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_content.php');
/**
* Page module link with teaser.
*
* This link comes with additional data which will be shown by another Category
*
* @package module_default
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class content_teaserlink extends base_content {

  var $cacheable = FALSE;

  var $editFields = array(
    'url'=>array ('URL', 'isNoHTML', TRUE, 'input', 200,'Please enter an URL (like "http://www.google.de" or "pages/index.hml"). Otherwise you can enter a papaya-page id (like "42")'),
    'title'=>array ('Title', 'isSomeText', TRUE, 'input', 60),
    'subtitle'=>array ('Subtitle', 'isSomeText', FALSE, 'input', 300),
    'teaser'=>array ('Teaser', 'isSomeText', FALSE, 'textarea', 10)
  );

  /**
  * Redirect to URL
  *
  * @access public
  */
  function getParsedData() {
    if (isset($this->data) && isset($this->data['url']) && 
        trim($this->data['url']) != '' && $this->data['url'] != $this->topicObj->topicId) {
      $GLOBALS['PAPAYA_PAGE']->sendHTTPStatus(301);
      $href = $this->getAbsoluteURL(@$this->data['url'], @$this->data['title'], TRUE);
      @header("Location: ".$href);
      printf ('<html><head><meta http-equiv="refresh" content="0; URL=%s"></head></html>', 
        papaya_strings::escapeHTMLChars($href));
      exit;
    }
  }

  /**
  * Get parsed teaser
  *
  * @access public
  * @return string
  */
  function getParsedTeaser() {
    $result = sprintf('<title encoded="%s">%s</title>'.LF,
      rawurlencode(@$this->data['title']), $this->getXHTMLString(@$this->data['title']));
    $result .= sprintf('<subtitle encoded="%s">%s</subtitle>'.LF,
      rawurlencode(@$this->data['subtitle']), $this->getXHTMLString(@$this->data['subtitle']));
    $result .= sprintf('<text>%s</text>'.LF,
      $this->getXHTMLString(@$this->data['teaser'], TRUE));
    return $result;
  }

}

?>