<?php
/**
* Page module - XHTML
*
* @package module_default
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: content_xhtml.php,v 1.4 2006/02/16 10:57:51 weinert Exp $
*/

/**
* Basic class page module
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_content.php');

/**
* Page module - XHTML
*
* @package module_default
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class content_xhtml extends base_content {

  var $editFields = array(
    'nl2br'=>array ('Automatic linebreak', 'isNum', FALSE, 'combo', array(0=>'Yes', 1=>'No'),
      'Papaya will apply your linebreaks to the output page.'),
    'text'=>array ('Text', 'isSomeText', FALSE, 'textarea', 30)
  );

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    $result = sprintf("<text>%s</text>", $this->getXHTMLString(@$this->data['text'], !((bool)@$this->data['nl2br'])));
    return $result;
  }

  /**
  * Get parsed teaser
  *
  * @access public
  * @return string
  */
  function getParsedTeaser() {
    $result = sprintf('<title>%s</title>'.LF,
                $this->getXHTMLString($this->topicObj->topic['TRANSLATION']['topic_title']));
    $teaser = str_replace("\r\n","\n",$this->data['text']);
    if (preg_match("/^(.+)([\n]{2})/sU", $teaser, $regs)) {
      $teaser = $regs[1];
    }
    $result .= sprintf('<text>%s</text>'.LF,
                $this->getXHTMLString($teaser, !((bool)$this->data['nl2br'])));
    return $result;
  }

}

?>