<?php
/**
* Catalog page navigation
*
* @package module_catalog
* @author Bodo Grassmann <grassmann@papaya-cms.com>
* @version $Id: actbox_catalog_limited_content.php,v 1.13 2006/06/01 10:27:08 kelm Exp $
*/

/**
* Basic class aktion box
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_actionbox.php');

/**
* Function class base_catalog
*/
include_once(dirname(__FILE__).'/base_catalog.php');
/**
* Catalog page navigation - outputs a list of catalog catagories and links to a catalog content page
*
* @package module_catalog
* @author Bodo Grassmann <grassmann@papaya-cms.com>
*/
class actionbox_catalog_limited_content extends base_actionbox {

  /**
  * Preview ?
  * @var boolean
  */
  var $preview = TRUE;
  
  /**
  * Content edit fields
  * @var array
  */
  var $editFields = array(
    'categ_base_id' => array ('Catalog Id', 'isNum', TRUE, 'input', 5, '', 0),
    'catalog_limit' => array ('Catalog Quantity', 'isNum', TRUE, 'input', 5, '', 0),
    'catalog_topic_unique' => array (
      'Catalog Topic Unique', 'isNum', FALSE, 'combo', 
      array(0=>'Yes', 1=>'No')
    ),
  );

  /**
  * Get output cache identifier
  *
  * @see base_actionbox::getCacheId()
  *
  * @access public
  * @return mixed Cache Id or FALSE
  */
  function getCacheId() {
    return parent::getCacheId(); //md5(get_class($this).','.@(int)$this->topicObj->topicId);
  }

  /**
  * Return page XML
  *
  * @access public
  * @return string $str
  */
  function getParsedData() {
    $pageId = @(int)$this->data['catalog_id'];    
    $className = get_class($this->topicObj);
    //if (isset($tmpTopicObj)){        
      $catalog = new base_catalog();
      $catalog->tableTopics = $this->topicObj->tableTopics;
      $catalog->tableTopicsTrans = $this->topicObj->tableTopicsTrans;
      $categId = @(int)$this->data['categ_base_id'];
      $catalog->loadCatalogLinkList($categId, $this->topicObj->getContentLanguageId(), 
         @(int)$this->data['catalog_limit'], @(bool)$this->data['catalog_topic_unique']);
      if (isset($catalog->linkList[$categId]) && is_array($catalog->linkList[$categId]) 
        && count($catalog->linkList[$categId]) > 0) {
          $str = sprintf('<subtopics>'.LF);
          foreach($catalog->linkList[$categId] as $link) {
            //$tmpTopicObj = new $className();  
            $str .= sprintf('<link title="%s" href="%s"/>'.LF,
              papaya_strings::escapeHtmlChars($link['cataloglink_title']), 
              $this->getWebLink($link['topic_id'], NULL, NULL, NULL, NULL, 
                $link['cataloglink_title'], @(int)$this->data['catalog_id']));
            $str .= '<subitem>';
            $str .= '<title>'.papaya_strings::escapeHtmlChars($link['cataloglink_title']).'</title>';
            $str .= '</subitem>';
            //$tmpTopicObj->loadOutput($link['topic_id'], $this->topicObj->currentLanguage['lng_ident']);
            //$str .= $tmpTopicObj->parseContent(FALSE);
            unset($tmpTopicObj);
          }
          $str .= '</subtopics>'.LF;
          return $str;
      }  
    //}
    return '';
    
  }
}
?>
