<?php
/**
* Page module Catalog
*
* @author Bodo Grassmann <grassmann@dimensional.de>
* @version $Id: content_catalog.php,v 1.20 2006/01/24 19:04:03 weinert Exp $
* @package papaya_module_catalog
*/

/**
* Basic class page module
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_content.php');

/**
* base catalog module
*/
include_once(dirname(__FILE__).'/base_catalog.php');

/**
* Page module Catalog
*
* @author Bodo Grassmann <grassmann@dimensional.de>
* @package papaya_module_catalog
*/
class content_catalog extends base_content {

  /**
  * Page content edit fields
  * @var array
  */
  var $editFields = array(
    'title' => array ('Title', 'isNoHTML', TRUE, 'input', 200, ''),
    'teaser' => array ('Teaser', 'isSomeText', FALSE, 'simplerichtext', 6, ''),
    'Start view categories',
    'categ' => array ('Category', 'isNum', TRUE, 'input', 200, '', 0),
    'catalog_offset' => array ('Offset', 'isNum', TRUE, 'input', 3, '', 1),
    'catalog_levels' => array ('Levels', 'isNum', TRUE, 'input', 3, '', 1),
    'Category teaser images',
    'cat_img_width' => array ('Width of category teaser image', 'isNum', FALSE, 'input', 10, ''),
    'cat_img_height' => array ('Height of category teaser image', 'isNum', FALSE, 'input', 10, ''),
    'cat_img_resize' => array ('Resize', 'isAlpha', TRUE, 'combo', 
      array('abs'=>'abs', 'max'=>'max', 'min'=>'min', 'mincrop'=>'mincrop'), '', 'max'),
    'Link teaser images',
    'img_width' => array ('Width', 'isNum', FALSE, 'input', 10, ''),
    'img_height' => array ('Height', 'isNum', FALSE, 'input', 10, ''),
    'img_resize' => array ('Resize', 'isAlpha', TRUE, 'combo', 
      array('abs'=>'abs', 'max'=>'max', 'min'=>'min', 'mincrop'=>'mincrop'), '', 'max'),
  );

  /**
  * Base catalog object
  * @var
  */
  var $catalog = NULL;

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    $result = sprintf('<title>%s</title>'.LF,
      $this->getXHTMLString(@$this->data['title']));
    $result .= sprintf("<teaser>%s</teaser>", $this->getXHTMLString(@$this->data['teaser']));
    $this->catalog = &new base_catalog();
    $this->catalog->module = &$this;
    $this->catalog->tableTopics = $this->topicObj->tableTopics;
    $this->catalog->tableTopicsTrans = $this->topicObj->tableTopicsTrans;
    $result .= $this->catalog->getOutput($this, $this->topicObj->getContentLanguageId());
    return $result;
  }
}

?>