<?php
/**
* Action box for RDF
*
* @package module_embed
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: actbox_rdf.php,v 1.2 2005/10/17 14:42:24 weinert Exp $
*/

/**
* Basic class aktion box
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_actionbox.php');

/**
* Action box for RDF
*
* read and cache XML-Content, transformed using  XSLT
*
* @package module_embed
* @author Bodo Grassmann <weinert@papaya-cms.com>
*/
class actionbox_rdf extends base_actionbox {

  /**
  * Preview possible ?
  * @var boolean
  */
  var $preview = TRUE;

  /**
  * Edit fields
  * @var array
  */
  var $editFields = array(
    'url'=>array ('URL', 'isNoHTML', TRUE, 'input', 800, 'Please input a relative or an absolute URL.'),
    'cachetime'=>array ('Cache time (minutes)', 'isNum', TRUE, 'input', 6, '', 1800),
    'max'=>array ('Count', 'isNum', TRUE, 'input', 5, '', '10'),
  );

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    $url = $this->data['url'];

    $cacheId = 'rdf_rss_'.md5($this->data['url']).'.xml';
    $cacheFileName = PAPAYA_PATH_CACHE.'.'.$cacheId;

    $xmlData = FALSE;
    if (file_exists($cacheFileName) && is_file($cacheFileName)) {
      $now = time();
      $cacheTime = filectime($cacheFileName)+((int)$this->data['cachetime']*60);
      if ($now < $cacheTime) {
        $xmlData = $this->loadCachefile($cacheFileName);
      }
    }
    if (!$xmlData) {
      $xmlData = $this->generateCachefile($this->data['url'], $cacheFileName);
    }

    return $xmlData;
  }

  /**
  * Generate cache file
  *
  * @param string $url
  * @param string $fileName
  * @access public
  * @return string
  */
  function generateCachefile($url, $fileName) {
    if (checkit::isHTTPX($url, TRUE)) {
      $str = implode('', file($url));
      if (($str != '') && ($fh = @fopen($fileName, 'w'))) {
        fwrite($fh, $str);
        fclose($fh);
      }
      return $str;
    }
    return '';
  }

  /**
  * Load chace file
  *
  * @param string $fileName
  * @access public
  * @return string
  */
  function loadCachefile($fileName) {
    if ($fh = fopen($fileName, 'r')) {
      $str = fread($fh, filesize($fileName));
      fclose($fh);
      return $str;
    }
    return '';
  }

}
?>
