<?php
/**
* Page rating box
*
* @package module_pagerating
* @author Bodo Grassmann <grassmann@papaya-cms.com>
* @version $Id: actbox_pagerating.php,v 1.14 2006/05/30 13:17:38 weinert Exp $
*/

/**
* Basic class aktion box
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_actionbox.php');

/**
* Page rating box
*
* @package module_pagerating
* @author Bodo Grassmann <grassmann@papaya-cms.com>
*/
class actionbox_pagerating extends base_actionbox {

  /**
  * Preview
  * @var boolean
  */
  var $preview = TRUE;

  /**
  * Parameter name
  * @var string
  */
  var $paramName = 'pr';

  /**
  * Content edit fields
  * @var array
  */
  var $editFields = array(
    'link_text' => array('Link Text', 'isSomeText', TRUE, 'input', 200, '', ''),
    'voted_text' => array('Voted Text', 'isSomeText', TRUE, 'input', 200, '', ''),
    'vote_deny' => array('Voted Deny', 'isSomeText', TRUE, 'input', 200, '', ''),
    'good_bad_rating' => array('Good/bad rating ?', 'isNum', TRUE, 'combo', array(1=>'Yes', 0=>'No'),
      'Rating selection contains only with good or bad'),
    'Rating Limits',
    'rating_min' => array('Min Number', 'isNum', FALSE, 'input', 200, '', '-1'),
    'rating_max' => array('Max Number', 'isNum', FALSE, 'input', 200, '', '1'),
    'Dynamic Image',
    'dynamic_image' => array('Dynamic Image', 'isAlpha', TRUE, 'input', 200, '', ''),
  );

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    include_once(dirname(__FILE__).'/base_pagerating.php');
    $this->pageratingObj = new base_pagerating();
    $this->pageratingObj->module = &$this;
    $this->pageratingObj->initialize();
    $str = $this->getBoxOutput();
    return $str;
  }


  /**
  * Box page output
  *
  * @access public
  * @return string xml
  */
  function getBoxOutput() {
    $result = '';
    $result .= '<pageranking>'.LF;
    if (!isset($this->params['vote']) && $this->pageratingObj->userCanVote($this->topicObj->topicId)) {
      $result .= '<links>'.LF;

      if (@$this->data['good_bad_rating']){
        $result .= sprintf('<link href="%s" value="%s" />'.LF,
          $this->getWebLink(NULL, NULL, NULL, array('vote' => -1), $this->paramName).'&'.$_SERVER['argv'][0], -1);
        $result .= sprintf('<link href="%s" value="%s" />'.LF,
          $this->getWebLink(NULL, NULL, NULL, array('vote' => 1), $this->paramName).'&'.$_SERVER['argv'][0], 1);
      } else {
        for($i = $this->data['rating_min']; $i <= $this->data['rating_max']; $i++){
          $result .= sprintf('<link href="%s" value="%s"/>'.LF,
            $this->getWebLink(NULL, NULL, NULL, array('vote' => $i), $this->paramName).'&'.@$_SERVER['argv'][0], $i);
        }
      }
      $result .= '</links>'.LF;
    } else {
      if (@$this->data['good_bad_rating']) {
        $this->data['rating_min'] = -1;
        $this->data['rating_max'] = 1;
      }
      if (isset($this->params['vote']) &&
          $this->params['vote'] >= @$this->data['rating_min'] &&
          $this->params['vote'] <= @$this->data['rating_max']) {
        if ($this->pageratingObj->addResult($this->topicObj->topicId, $this->topicObj->getContentLanguageId(), @(int)$this->params['vote'])){
          $result .= sprintf('<message>%s</message>', $this->data['voted_text']);
        } else {
          $result .= sprintf('<message>%s</message>', $this->data['vote_deny']);
        }
      }
      if ($this->pageratingObj->loadPageList($this->topicObj->getContentLanguageId())){
        $this->pageratingObj->loadTopicTitle($this->topicObj->getContentLanguageId());
        $this->pageratingObj->calculateRating();
        if (isset($this->pageratingObj->pageList[$this->topicObj->topicId]['rating'])) {
          $rating = $this->pageratingObj->pageList[$this->topicObj->topicId]['rating'];
          if (isset($this->data['dynamic_image']) && $this->data['dynamic_image'] != '') {
            $src = ' src="'.$this->escapeForFilename($this->data['dynamic_image'], 'index').'.image.jpg"';
          } else {
            $src = '';
          }
          $result .= sprintf('<rating value="%d" votes="%d"%s/>',
            $rating, $this->pageratingObj->pageList[$this->topicObj->topicId]['votes'], $src);
        }
      }
    }
    $result .= '</pageranking>'.LF;
    return $result;
  }

  function getCacheId() {
    return FALSE;
  }
}
?>
