<?php
/**
* Page module - Podcast Item
*
* @package module_default
* @author Alexander Chritmann <christmann@datenwelt.net>
* @version $Id: content_podcast_item.php,v 1.5 2006/04/26 11:34:15 christmann Exp $
*/

/**
* Basic class Page module
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_content.php');

/**
* File manager
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_fileman.php');

/**
* Page module - article with image
*
* @package module_default
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class content_podcast_item extends base_content {

  var $editFields = array(
    'mediafile'=>array ('Mediafile', 'isSomeText', TRUE, 'mediafile', 200),  
    'title'=>array ('Title', 'isNoHTML', TRUE, 'input', 400),
    'subtitle'=>array ('Subtitle', 'isNoHTML', FALSE, 'input', 400),
    'summary'=>array ('Summary', 'isNoHTML', FALSE, 'textarea', 10),
    'keywords'=>array ('Keywords', 'isNoHTML', FALSE, 'textarea', 10),
    'author'=>array ('Author', 'isNoHTML', FALSE, 'input', 30),
  );

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  
  /* Diese Methode wird eigentlich nicht benutzt.
     Da Podcast Elemente eigentlich nie einzeln
     aufgerufen werden und es fuer sie auch keinen
     eigenen View gibt.
  */
  function getParsedData() {
    $result = sprintf('<title encoded="%s">%s</title>'.LF,
      rawurlencode(@$this->data['title']), $this->getXHTMLString(@$this->data['title']));
    $result .= sprintf('<subtitle>%s</subtitle>'.LF,
      $this->getXHTMLString(@$this->data['subtitle']));
    $result .= sprintf('<summary>%s</summary>'.LF,
      $this->getXHTMLString(@$this->data['summary']));
    $result .= sprintf("<author>%s</author>",
      $this->getXHTMLString(@$this->data['author']));
    return $result;
  }

  /**
  * Get parsed teaser
  *
  * @access public
  * @return string
  */
  function getParsedTeaser() {
  
    $fileManager = &new base_filemanager;
    $fileManager->initializeParams();
    $fileManager->baseLink = $this->baseLink;
    $fileManager->dataDirectory = PAPAYA_PATH_MEDIAFILES;
      
    if (isset($this->data['mediafile']) && $this->data['mediafile'] != '' && $fileManager->dataLoadFile(@$this->data['mediafile'])) { 
      $val = $fileManager->selectedFile;
      $fileTitle = ($val['file_name'] != $val['file_id']) ? $val['file_name'] : '';
      $href = $fileManager->getWebMediaLink($val['file_id'], 'download', $fileTitle);
      
      $result = sprintf('<file download="%s" file_date="%s" file_size_human="%d" file_size="%d" file_type="%s" file_name="%s" file_id="%s"/>'.LF, 
        $href,
        date('Y-m-d H:i:s', $val['file_date']),    
        round((int)$val['file_size'] / 1024),
        (int)$val['file_size'],
        htmlspecialchars($fileManager->getMimeType($val['file_type'], $val['file_id'])),
        htmlspecialchars($val['file_name']),
        $this->getXHTMLString(@$this->data['mediafile']));      
         
      $result .= sprintf('<title>%s</title>'.LF,
        $this->getXHTMLString(@$this->data['title']));
      $result .= sprintf('<subtitle>%s</subtitle>'.LF,
        $this->getXHTMLString(@$this->data['subtitle']));
      $result .= sprintf('<summary>%s</summary>'.LF,
        $this->getXHTMLString(@$this->data['summary'], TRUE));
        
      $result .= sprintf('<keywords>%s</keywords>', 
        $this->getXHTMLString(@$this->data['keywords']));
      
      $result .= sprintf('<author>%s</author>'.LF,
        $this->getXHTMLString(@$this->data['author']));
  
      return $result;
    }

  return '';
  }
}

?>