<?php
/**
* Seitenmodul Voting
*
* @package module_poll
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: content_poll.php,v 1.3 2006/01/12 17:23:11 weinert Exp $
*/

/**
* Basisklasse Seitenmodule
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_content.php');
/**
* Poll Funktionsklasse
*/
include_once(dirname(__FILE__).'/base_poll.php');

/**
* Seitenmodul Voting
*
* @author Thomas Weinert <weinert@papaya-cms.com>
* @package module_poll
*/
class content_poll extends base_content {

  var $editFields = array(
    'nl2br'=>array ('Automatic linebreak', 'isNum', FALSE, 'combo', array(0=>'Yes', 1=>'No'),
      'Apply linebreaks from input to the HTML output.'),
    'title'=>array ('Title', 'isSomeText', TRUE, 'input', 400),
    'text'=>array ('Text', 'isSomeText', FALSE, 'richtext', 30),
    'poll'=>array ('Category / Poll', 'isNoHTML', TRUE, 'function', 'getPollCombo', ''),
    'Messages',
    'error_nopoll'=>array ('No poll', 'isNoHTML', TRUE, 'input', 400, '', 'No poll defined.')
  );

  function getParsedData() {
    $result = sprintf('<title encoded="%s">%s</title>'.LF,
      rawurlencode(@$this->data['title']), $this->getXHTMLString(@$this->data['title']));
    $result .= sprintf("<text>%s</text>",
      $this->getXHTMLString(@$this->data['text'], !((bool)@$this->data['nl2br'])));
    $poll = &new base_poll();
    $poll->module = &$this;
    $result .= $poll->getOutput($this->data);
    return $result;
  }

  function getPollCombo($name, $field, $data) {
    $this->pollObject = &new base_poll();
    $this->pollObject->loadCategs();
    $this->pollObject->loadPolls();
    $result = sprintf('<select name="%s[%s]" class="dialogSelect dialogScale">'.LF,
    $this->paramName, $name);
    @list($mode, $dataId) = explode(';', $data);
    if (isset($this->pollObject->categs) && is_array($this->pollObject->categs)) {
      foreach ($this->pollObject->categs as $id=>$categ) {
        $categName = "[".$categ['categ_title']."] ";
        $selected = ($mode == 'categ' && $dataId == $categ['categ_id']) ? ' selected="selected"' : '';
        $result .= sprintf('<option value="categ;%d" %s>%s</option>'.LF,
        $categ['categ_id'],
        $selected,
        $categName
        );
        if (isset($this->pollObject->polls) && is_array($this->pollObject->polls)) {
          foreach ($this->pollObject->polls as $id=>$poll) {
            $selected = ($mode == 'poll' && $dataId == $poll['poll_id']) ? ' selected="selected"' : '';
            if ($poll['categ_id'] == $categ['categ_id']){
              $result .= sprintf('<option value="poll;%d" %s>%s</option>'.LF,
              $poll['poll_id'],
              $selected,
              "&nbsp;&nbsp;&nbsp;&nbsp;'->".htmlspecialchars($poll['question'])
              );
            }
          }
        }
      }
    }
    $result .= '</select>'.LF;
    return $result;
  }
}
?>
