<?php
/**
*
* @author Bodo Grassmann <grassmann@dimensional.de>
* @version $Id: actbox_quiz.php,v 1.8 2006/02/17 18:03:11 weinert Exp $
* @package module_quiz
*/

/**
* Basic class aktion box
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_actionbox.php');

/**
* Function class quiz
*/
include_once(dirname(__FILE__).'/base_quiz.php');

/**
* Action box quiz
*
* @package module_quiz
* @author Bodo Grassmann <grassmann@dimensional.de>
*/
class actionbox_quiz extends base_actionbox {

  var $preview = TRUE;
  /**
  * Language Select
  * @var array
  */
  var $lngSelect = NULL;

  /**
  * Quiz objeckt
  * @var array
  */
  var $quizObject = NULL;

  /**
  * Parameter name
  * @var string
  */
  var $paramName = 'pr';

  /**
  * edit fields
  * @var array
  */
  var $editFields = array(
    'title' => array ('Title', 'isNoHTML', TRUE, 'input', 255),
    'quiz' => array ('Quiz', 'isNoHTML', TRUE, 'function', 'getQuizCombo', '')
  );

  /**
  * Get parsed data
  *
  * @access public
  * @return string xml
  */
  function getParsedData() {
    $this->quizObject = &new base_quiz();
    $this->quizObject->module = &$this;
    $this->quizObject->initialize();
    $str = $this->quizObject->getBoxOutput($this, $this->data);
    return $str;
  }

  /**
  * Get quiz combo for content selection
  *
  * @param string $name
  * @param array $field
  * @param array $data
  * @access public
  * @return string xml
  */
  function getQuizCombo($name, $field, $data) {
    include_once(PAPAYA_INCLUDE_PATH.'system/base_language_select.php');
    $this->lngSelect = &base_language_select::getInstance();
    $lngId = $this->lngSelect->currentLanguageId;
    $this->quizObject = &new base_quiz();
    $this->quizObject->loadGroupTree($lngId);
    $result = sprintf('<select name="%s[%s]" class="dialogSelect dialogScale">'.LF,
    $this->paramName, $name);
    if (isset($this->quizObject->groups) && is_array($this->quizObject->groups)) {
      $result .= $this->getQuizComboSubTree(0,0, $data);
    }
    $result .= '</select>'.LF;
    return $result;
  }

  /**
  * Get quiz combo sub tree
  *
  * @param integer $parent
  * @param integer $indent
  * @param array $data
  * @access public
  * @return string xml
  */
  function getQuizComboSubTree($parent, $indent, $data) {
    $result = '';
    if (isset($this->quizObject->groupTree[$parent]) && is_array($this->quizObject->groupTree[$parent])) {
      foreach($this->quizObject->groupTree[$parent] as $id) {
        $result .= $this->getQuizComboEntry($id, $indent, $data);
      }
    }
    return $result;
  }

  /**
  * Get quiz combo entry
  *
  * @param integer $id
  * @param integer $indent
  * @param array $data
  * @access public
  * @return string xml
  */
  function getQuizComboEntry($id, $indent, $data) {
    $result = '';
    if (isset($this->quizObject->groups[$id]) && is_array($this->quizObject->groups[$id])) {
      $group = $this->quizObject->groups[$id];
      if ($indent > 0) {
        $indentString = "'".str_repeat('-', $indent).'->';
      } else {
        $indentString = '';
      }
      $title = $this->quizObject->groups[$id]['groupdetail_title'];
      if (!isset($title) || $title == ''){
        $title = 'No Title for this Language';
      }
      $selected = ($data == $id) ? ' selected="selected"' : '';
      $result .= sprintf('<option value="%d" %s>%s %s</option>'.LF,
        $id, $selected ,
        $indentString, papaya_strings::escapeHTMLChars($title));
      $result .= $this->getQuizComboSubTree($id, $indent+1, $data);
    }
    return $result;
  }
}
?>