<?php
/**
* Page module - Thumbnail Gallery.
*
* @package module_mediadb
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: content_thumbs.php,v 1.5 2006/01/12 17:23:11 weinert Exp $
*/

/**
* Basic class page module
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_content.php');
/**
* File manager
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_fileman.php');
/**
* Page module - Thumbnail Gallery.
*
* @package module_mediadb
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class content_thumbs extends base_content {

  /**
  * Content edit fields
  * @var array
  */
  var $editFields = array(
    'directory'=>array ('Folder', 'isNum', TRUE, 'function', 'mediadirectory', '', 0),
    'maxperpage'=>array ('Thumbnail count', 'isNum', TRUE, 'input', 5, '', 9),
    'maxperline'=>array ('Column count', 'isNum', TRUE, 'input', 5, '', 3),
    'thumbwidth'=>array ('Thumbnail width', 'isNum', TRUE, 'input', 5, '', 100),
    'thumbheight'=>array ('Thumbnail height', 'isNum', TRUE, 'input', 5, '', 100),
    'width'=>array ('Width', 'isNum', TRUE, 'input', 5, '', 640),
    'height'=>array ('Height', 'isNum', TRUE, 'input', 5, '', 480),
    'text'=>array ('Text', 'isSomeText', FALSE, 'textarea', 10)
  );

  /**
  * Get parsed data
  *
  * @access public
  * @return string
  */
  function getParsedData() {
    $this->paramName = 'bab';
    $this->initializeParams();
    $result = sprintf("<text>%s</text>".LF, $this->getXHTMLString(@$this->data['text'], TRUE));
    $result .= '<options>'.LF;
    $result .= sprintf("<maxperline>%d</maxperline>".LF, (int)@$this->data['maxperline']);
    $result .= sprintf("<thumbwidth>%d</thumbwidth>".LF, (int)@$this->data['thumbwidth']);
    $result .= sprintf("<thumbheight>%d</thumbheight>".LF, (int)@$this->data['thumbheight']);
    $result .= sprintf("<width>%d</width>".LF, (int)@$this->data['width']);
    $result .= sprintf("<height>%d</height>".LF, (int)@$this->data['height']);
    $result .= '</options>'.LF;

    $fileManager = &new base_filemanager;
    $fileManager->initializeParams();

    $fileManager->dataDirectory = PAPAYA_PATH_MEDIAFILES;
    $fileManager->thumbnailDirectory = PAPAYA_PATH_THUMBFILES;
    $fileManager->folderId = (int)$this->data['directory'];

    $fileManager->dataLoadFileList($this->topicObj->getContentLanguageId(),TRUE,TRUE);

    $count = count($fileManager->files);
    $min = (int)@$this->params['idx'];
    if ($min < 0) {
      $min = 0;
    } elseif ($min >= $count) {
      $min = $count - (int)$this->data['maxperpage'] - 1;
    }
    $max = @$this->params['idx'] + (int)$this->data['maxperpage'];
    if ($max > $count) {
      $max = $count;
    }

    if ((@$this->params['mode'] == 'max') && ($this->params['img'] >= 0)) {
      //Groe Ansicht
      $result .= '<image>';
        $file = $fileManager->files[$this->params['img']];
        $result .= sprintf('<papaya:media src="%s" width="%d" height="%d" align="center"/>'.LF,
          $file['file_id'], (int)$this->data['width'], (int)$this->data['height']);
      $result .= '</image>';
      $result .= sprintf('<imagetitle>%s</imagetitle>', htmlspecialchars($file['file_title']));
      $result .= sprintf('<imagecomment>%s</imagecomment>', $this->getXHTMLString($file['file_comment'], TRUE));
      $result .= '<navigation>'.LF;
      $result .= sprintf('<navlink dir="index" href="%s?%s[idx]=%d" />'.LF,
        $this->baseLink, $this->paramName, (int)$this->params['idx']);
      $result .= '</navigation>'.LF;
    } else {
      $result .= '<thumbnails>'.LF;
      for ($i = $min; $i < $max; $i++) {
        $file = $fileManager->files[$i];
        $href = $this->getLink(
          array('mode'=>'max', 'idx'=>(int)@$this->params['idx'], 'img'=>$i, 'page_id' => $this->topicObj->topicId));
        $result .= sprintf('<thumb><papaya:media href="%s" src="%s" width="%d" height="%d" align="none" subtitle="%s" title="%s" /></thumb>'.LF,
          $href, $file['file_id'], (int)$this->data['thumbwidth'], (int)$this->data['thumbheight'], htmlspecialchars($file['file_title']), htmlspecialchars($file['file_title']));
      }
      $result .= '</thumbnails>'.LF;
      $result .= '<navigation>'.LF;
      if ($max < $count) {
        $result .= sprintf('<navlink dir="next" href="%s?%s[idx]=%d" />'.LF,
          $this->baseLink, $this->paramName, (int)$max);
      }
      if ($min > 0) {
        $min -= $this->data['maxperpage'];
        if ($min < 0) $min = 0;
        $result .= sprintf('<navlink dir="prior" href="%s?%s[idx]=%d" />'.LF,
          $this->baseLink, $this->paramName, (int)$min);
      }
      $result .= '</navigation>'.LF;
    }

    return $result;
  }

  /**
  * Media directory
  *
  * @param string $name
  * @param array $field
  * @param integer $data
  * @access public
  * @return string
  */
  function mediadirectory($name, $field, $data) {
    $result = '';
    include_once(PAPAYA_INCLUDE_PATH.'system/papaya_fileman.php');
    $fileManager = &new papaya_filemanager;
    $fileManager->initialize();

    $fileManager->dataDirectory = PAPAYA_PATH_MEDIAFILES;
    $fileManager->thumbnailDirectory = PAPAYA_PATH_THUMBFILES;

    $fileManager->dataLoadFolderList($this->topicObj->getContentLanguageId());
    $this->folders = $fileManager->folders;
    if ( isset($fileManager->folderLinks))
      $this->folderLinks = $fileManager->folderLinks;

    $result .= sprintf('<select name="%s[%s]" class="dialogSelect dialogScale">'.LF,
      $this->paramName, $name);
    $result .= $this->getFolder(0,(int)$data, 0);
    $result .= '</select>'.LF;

    return $result;
  }

  /**
  * Get folder
  *
  * @param integer $id
  * @param integer $selId
  * @param integer $indent optional, default value 0
  * @access public
  * @return string
  */
  function getFolder($id, $selId, $indent=0) {
    $result = '';
    $folder = $this->folders[$id];
    $subFolders = @$this->folderLinks[$id]['CHILDS'];
    if (isset($folder) && is_array($folder)) {
      if ($selId == $id) {
        $selected = ' selected="selected"';
      } else {
        $selected = '';
      }
      $result .= sprintf('<option value="%d"%s>%s%s</option>'.LF,
        $folder['folder_id'], $selected, str_repeat('-',$indent*2), htmlspecialchars($folder['folder_title']));
      if (isset($subFolders) && is_array($subFolders)) {
        foreach($subFolders as $sub) {
          $result .= $this->getFolder($sub, $selId, $indent+1);
        }
      }
    }
    return $result;
  }

}

?>