<?php
/**
* Base class of action box objects
*
* box plugins must be inherited from this superclass
*
* @package papaya_modules
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: base_actionbox.php,v 1.4 2006/01/12 15:30:56 weinert Exp $
*/

/**
* Base class for plugins
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_plugin.php');

/**
* Base class of action box objects
*
* box plugins must be inherited from this superclass
*
* @package papaya_modules
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class base_actionbox extends base_plugin {

  /**
  * Css class
  * @var string
  */
  var $inputFieldSize = 'x-large';

  /**
  * box record database id
  * @var integer
  */
  var $boxId;

  /**
  * Is the output cacheable?
  */
  var $cacheable = TRUE;

  /**
  * Return page XML
  * @return string
  */
  function getParsedData() {
    return '';
  }

  /**
  * Get output cache identifier
  *
  * @access public
  * @return mixed Cache Id or FALSE
  */
  function getCacheId() {
    if ($this->cacheable) {
      return md5(get_class($this));
    } else {
      return FALSE;
    }
  }

  /**
  * Delete output cache of current box
  *
  * @access public
  */
  function deleteCache() {
    if ($dh = opendir(PAPAYA_PATH_CACHE)) {
      while($file = readdir($dh)) {
        if (preg_match('#^\.box_'.(int)$this->boxId.'_\d+_[a-f\d]{32}(\.\w+)?$#', $file)) {
          unlink(PAPAYA_PATH_CACHE.$file);
        }
      }
      closedir($dh);
    }
  }
}
?>