<?php
/**
* Transform text to ASCII-graphic
*
* @package papaya
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: base_ascii_gfx.php,v 1.3 2006/04/20 18:24:00 weinert Exp $
*/

/**
* Transform text to ASCII-graphic
*
* @package papaya
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class base_ascii_gfx {
  /**
  * letters
  * @var array
  */
  var $letters = NULL;

  function __construct() {
    $this->letters = array(
0 => '
 _____
|  _  |
| | | |
| | | |
| |_| |
|_____|
',
1 => '
 ___
|_  |
  | |
  | |
  | |
  |_|
',
2 => '
 _____
|___  |
 ___| |
|  ___|
| |___
|_____|
',
3 => '
 _____
|___  |
   _| |
  |_  |
 ___| |
|_____|
',
4 => '
 _   _
| | | |
| |_| |
|___  |
    | |
    |_|
',
5 => '
 _____
|  ___|
| |___
|___  |
 ___| |
|_____|
',
6 => '
 _____
|  ___|
| |___
|  _  |
| |_| |
|_____|
',
7 => '
 _____
|___  |
    | |
    | |
    | |
    |_|
',
8 => '
 _____
|  _  |
| |_| |
|  _  |
| |_| |
|_____|
',
9 => '
 _____
|  _  |
| |_| |
|___  |
 ___| |
|_____|
',
'A' => '
 _____
|  _  |
| |_| |
|  _  |
| | | |
|_| |_|
',
'B' => '
 _____
|  _  |
| |_| |
|  _ <
| |_| |
|_____|
',
'C' => '
 _____
|  ___|
| |
| |
| |___
|_____|
',
'D' => '
 ____
|  _ \
| | | |
| | | |
| |_| |
|____/
',
'E' => '
 _____
|  ___|
| |_
|  _|
| |___
|_____|
',
'F' => '
 _____
|  ___|
| |_
|  _|
| |
|_|
',
'G' => '
 _____
|  ___|
| |  _
| | \ \
| |_| |
|_____|
',
'H' => '
 _   _
| | | |
| |_| |
|  _  |
| | | |
|_| |_|
',
'I' => '
 _
| |
| |
| |
| |
|_|
',
'K' => '
 _   _
| | / /
| |/ /
|   <
| |\ \
|_| \_\
',
'L' => '
 _
| |
| |
| |
| |___
|_____|
',
'M' => '
 __    __
|  \  /  |
|   \/   |
| |\__/| |
| |    | |
|_|    |_|
',
'M' => '
 __    _
|  \  | |
|   \ | |
| |\ \| |
| | \   |
|_|  \__|
',
'O' => '
 _____
|  _  |
| | | |
| | | |
| |_| |
|_____|
',
'P' => '
 _____
|  _  |
| |_| |
|  ___|
| |
|_|
',
'Q' => '
 ______
|  __  |
| |  | |
| | _| |
| |_\  \
|_______|
',
'R' => '
 _____
|  _  |
| |_| |
|  _ <
| | \ |
|_| |_|
',
'S' => '
 _____
|  ___|
| |___
|___  |
 ___| |
|_____|
',
'T' => '
 _____
|_   _|
  | |
  | |
  | |
  |_|
',
'U' => '
 _   _
| | | |
| | | |
| | | |
| |_| |
|_____|
',
'U' => '
 _   _
| | | |
| | | |
| | | |
\ \_/ /
 \___/
',
'U' => '
 _        _
| |      | |
| |      | |
| |  __  | |
\ \_/  \_/ /
 \___/\___/
',
'X' => '
 _   _
| | | |
\ \_/ /
 | _ |
/ / \ \
|_| |_|
',
'X' => '
 _   _
| | | |
\ \_/ /
 \   /
  | |
  |_|
',
'Z' => '
 _____
|___  |
   / /
  / /
 / /__
|_____|
',
'-' => '


 _____
|_____|


',
'+' => '

    _
 _| |_
|_   _|
  |_|

',
':' => '

    _
  |_|
    _
  |_|

');
  }

  /**
  * PHP 4 constuctor redirect
  *
  * @access public
  */
  function base_ascii_gfx() {
    $args = func_get_args();
    call_user_func_array(array(&$this, '__construct'), $args);
  }

  /**
  * Return ASCII graphic string
  *
  * @param $str
  * @access public
  * @return string
  */
  function getAsciiString($str) {
    $str = strtoupper((string)$str);
    $max = strlen($str);
    $result = array();
    for ($i = 0; $i < $max; $i++) {
      if (isset($this->letters[$str{$i}])) {
        $char = explode("\n", $this->letters[$str{$i}]);
        $length = 0;
        foreach($char as $charStr) {
          if (strlen($charStr) > $length) $length = strlen($charStr);
        }
        $length++;
        foreach($char as $line=>$charStr) {
          @$result[$line] .= str_pad(chop($charStr), $length, ' ', STR_PAD_RIGHT);
        }
      }
    }
    return join("\n", $result);
  }
}

?>