<?php
/**
* Basic object for all event box objects (Calendar)
*
* @package papaya
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: base_eventbox.php,v 1.3 2006/04/20 18:24:00 weinert Exp $
*/


/**
* Base class plugin
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_plugin.php');
/**
* Basic object for all event box objects (Calendar)
*
* Event box objects must inherit this class
*
* @package papaya_modules
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class base_eventbox extends base_plugin {
  /**
  * Base eventbox
  *
  * @param object calendar &$calendar
  * @access public
  */
  function __construct(&$calendar) {
    $args = func_get_args();
    $this->calendar = &$calendar;
    $this->topicObj = NULL;
    if (isset($args[1])) {
      $this->paramName = $this->getParamname($args[1]);
    } else {
      $this->paramName = $this->getParamname($paramName='bab');
    }
    $this->initializeParams();
    $this->baseLink = $this->getBaseLink();
  }

  /**
  * PHP 4 constructor redirect
  *
  * @param object calendar &$calendar
  * @access public
  */
  function base_eventbox(&$calendar) {
    $this->__construct($calendar);
  }

  /**
  * Take over XML for site
  * @return string
  */
  function getParsedData() {
    return '';
  }

  /**
  * Initialisize dialog
  *
  * @access public
  */
  function initializeDialog() {
    if (!@is_object($this->dialog)) {
      include_once(PAPAYA_INCLUDE_PATH.'system/base_dialog.php');
      $hidden = array(
        'save'=>1,
        'mode'=>$this->calendar->sessionParams['mode']
      );
      if (isset($this->calendar->regular['calreg_id'])) {
        $hidden['regtopic'] = @$this->calendar->regular['calreg_id'];
      } else {
        $hidden['topic'] = @$this->calendar->loadedTopic['topic_id'];
      }
      $this->dialog = &new base_dialog($this, $this->paramName, $this->editFields, $this->data, $hidden);
      $this->dialog->msgs = &$this->msgs;
      $this->dialog->loadParams();
      $this->dialog->inputFieldSize = $this->inputFieldSize;
      $this->dialog->paramName = $this->paramName;
      $this->dialog->baseLink = $this->baseLink;
    }
  }
}
?>