<?php
/**
* Navigation object with dependencies to user object
*
* @package papaya
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: base_navigation.php,v 1.2 2005/10/21 10:02:27 weinert Exp $
*/


/**
* basic class database access
*/
require_once(PAPAYA_INCLUDE_PATH.'system/sys_base_object.php');
/**
* Navigation object with dependencies to user object
*
* @package papaya
* @author Thomas Weinert <weinert@papaya-cms.com>
*/
class base_navigation extends base_object {

  /**
  * Place navigation
  */
  function setGroup($menuGroup, $fileName='') {
    if (isset($menuGroup) && is_array($menuGroup)) {
      foreach($menuGroup as $menuTitle=>$menuData) {
        $this->setMenu($menuTitle, $menuData, $fileName);
      }
    }
  }

  /**
  * Set menu
  *
  * @param string $menuTitle
  * @param array $menu
  * @param string $fileName optional, default value ''
  * @access public
  */
  function setMenu($menuTitle, $menu, $fileName='') {
    if (isset($menu) && is_array($menu)) {
      if (($buttonString = $this->getButtons($menu, $fileName))) {
        $this->layout->addMenu(sprintf('<menu ident="%s">%s</menu>'.LF, $menuTitle, $buttonString));
      }
    }
  }

  /**
  * Get buttons
  *
  * @param array $menuData
  * @param string $fileName optional, default value ''
  * @access public
  * @return mixed
  */
  function getButtons($menuData,$fileName='') {
    $buttonString = FALSE;
    if (isset($menuData) && is_array($menuData)) {
      foreach($menuData as $btn) {
        if ($btn[0] == '-') {
          $buttonString .= '-';
        } else {
          $glyphAttributes = (strpos(@$btn[2], '?')>0) ? 'glyphscript' : 'glyph';
          $down = ((@$btn[6]) || (($fileName == @$btn[4]) && ($fileName != ''))) ? ' down="down"' : '';
          $accessKey = (@$btn[7]) ? sprintf(' accesskey="%s"', @$btn[7]) : '';
          if (!@$btn[8]) {
            $caption = $this->_gt(@$btn[0]);
            $hint = $this->_gt(@$btn[1]);
          } else {
            $caption = @$btn[0];
            $hint = @$btn[1];
          }
          if ((@$btn[3] == 0) || ($this->authUser->hasPerm(@$btn[3]))) {
            $buttonString .= sprintf('<button title="%s" hint="%s" %s="%s" href="%s" target="%s"%s%s />'.LF,
              papaya_strings::escapeHTMLChars($caption), papaya_strings::escapeHTMLChars($hint), $glyphAttributes,
              @$btn[2], @$btn[4], @$btn[5], $down, $accessKey);
          }
        }
      }
      $buttonString = preg_replace('/(^-+)|(--+)|(-+$)/', '', $buttonString);
      if ($buttonString != '') {
        $buttonString = preg_replace('/(>\s*)-(\s*<)/', '\1<seperator/>\2', $buttonString);
      } else {
        $buttonString = FALSE;
      }
    }
    return $buttonString;
  }
}


?>