<?php
/**
* Basic options of papaya project
*
* @package papaya
* @author Thomas Weinert <weinert@papaya-cms.com>
* @version $Id: base_options.php,v 1.26 2006/05/31 14:29:50 weinert Exp $
*/

/**
* Basic class database access
*/
require_once(PAPAYA_INCLUDE_PATH.'system/sys_base_db.php');
/**
* Basic class check conditions
*/
require_once(PAPAYA_INCLUDE_PATH.'system/sys_checkit.php');

/**
* Basic options of papaya-cms
*
* @author Thomas Weinert <weinert@papaya-cms.com>
* @package papaya
*/
class base_options extends base_db {
  var $tableOptions = PAPAYA_DB_TBL_OPTIONS;

  var $options;
  var $optionGroups;
  var $optLinks;

  var $optFields = array(
    'PAPAYA_DBG_DATABASE_ERROR'   => array (3, 'isNum', 'combo', array(1=>'on',0=>'off'), 1),
    'PAPAYA_DBG_DATABASE_EXPLAIN' => array (3, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),
    'PAPAYA_DBG_XML_OUTPUT'       => array (3, 'isNum', 'combo', array(1=>'on',0=>'off'), 1),
    'PAPAYA_DBG_XML_ERROR'        => array (3, 'isNum', 'combo', array(1=>'on',0=>'off'), 1),
    'PAPAYA_DBG_RUNTIME_XSLT'     => array (3, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),
    'PAPAYA_DBG_RUNTIME_PHP'      => array (3, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),
    'PAPAYA_DBG_XML_USERINPUT'    => array (3, 'isNum', 'combo', array(1=>'on',0=>'off'), 1),
    'PAPAYA_DBG_PHRASES'          => array (3, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),
    'PAPAYA_DBG_PHP_ERROR'        => array (3, 'isNum', 'combo',
      array(0=>'None', 2039=>'E_ALL ^ E_NOTICE', 1015=>'E_ALL ^ (E_NOTICE | E_USER_NOTICE)',
            2047=>'E_ALL'),
      2039),
    'PAPAYA_DBG_PHP_CAPTURE_ERROR'    => array (3, 'isNum', 'combo', array(1=>'on',0=>'off'), 1),
    'PAPAYA_DBG_PHP_SHOW_ERROR'    => array (3, 'isNum', 'combo', array(1=>'on',0=>'off'), 1),
    'PAPAYA_DBG_PHP_LOG_ERROR'    => array (3, 'isNum', 'combo', array(1=>'on',0=>'off'), 1),

    'PAPAYA_PATH_DATA'      => array (2, 'isPath', 'input', '100', ''),
    'PAPAYA_PATH_WEB'         => array (2, 'isPath', 'input', '100', '/'),

    'PAPAYA_PROJECT_TITLE'    => array (5, 'isNoHTML', 'input', '50', 'Papaya-Project'),
    'PAPAYA_CACHE_TIME'       => array (5, 'isNum', 'input', '5', 0),
    'PAPAYA_COMPRESS_OUTPUT'  => array (5, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),
    'PAPAYA_START_SESSION'    => array (5, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),
    'PAPAYA_CONTENT_LANGUAGE' => array (5, 'isNum', 'function', 'getContentLanguageCombo', 1),
    'PAPAYA_DEFAULT_HOST'     => array (5, 'isHTTPHost', 'input', '40', ''),
    'PAPAYA_DEFAULT_HOST_ACTION' => array (5, 'isNum', 'combo', array('0'=>'None', '1'=>'Redirect'), ''),
    'PAPAYA_PAGE_STATISTIC'    => array (5, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),
    'PAPAYA_STATISTIC_PRESERVE_IP'     => array (5, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),
    'PAPAYA_STATISTIC_PRESERVE_USERID' => array (5, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),

    'PAPAYA_VERSIONS_MAXCOUNT'=> array (7, 'isNum', 'input', '5', 200),
    'PAPAYA_UI_THEME'         => array (7, 'isAlpha', 'dircombo', array('themes/', 'admin'), 'default'),
    'PAPAYA_UI_LANGUAGE'      => array (7, 'isAlpha', 'function', 'getInterfaceLanguageCombo', 'en_US'),
    'PAPAYA_OFFLINE_MODE'     => array (7, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),
    'PAPAYA_USE_RICHTEXT'     => array (7, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),
    'PAPAYA_USE_FLASHCONTROLS'=> array (7, 'isNum', 'combo', array(1=>'on',0=>'off'), 1),
    'PAPAYA_MAX_UPLOAD_SIZE'  => array (7, 'isNum', 'input', 3, 7),
    'PAPAYA_XSLT_EXTENSION'   => array (7, 'isAlpha', 'function', 'getXSLTExtensionsCombo', ''),
    'PAPAYA_BROWSER_CRONJOBS'   => array (7, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),
    'PAPAYA_BROWSER_CRONJOBS_IP'   => array (7, 'isAlphaNumChar', 'input', 15, '127.0.0.1'),
    'PAPAYA_URL_NAMELENGTH'    => array (7, 'isNum', 'input', 3, 50),
    'PAPAYA_URL_EXTENSION'    => array (7, 'isAlpha', 'combo',
      array('html'=>'html', 'php'=>'php', 'papaya'=>'papaya'), 'html'),
    'PAPAYA_SEARCH_BOOLEAN'   => array (7, 'isNum', 'combo', array(0=>'generic SQL (LIKE)',1=>'MySQL FULLTEXT', 2=>'MySQL FULLTEXT BOOLEAN (MySQL >= 4.1)'), 0),
    'PAPAYA_THUMBS_FILETYPE'  => array (7, 'isNum', 'combo', array(1=>'GIF', 2=>'JPEG', 3=>'PNG'), 2),
    'PAPAYA_THUMBS_JPEGQUALITY'  => array (7, 'isNum', 'input', 3, 60),
    'PAPAYA_SESSION_ID_FALLBACK' => array (7, 'isAlpha', 'combo', array('none'=>'None','rewrite'=>'Path Rewrite','get'=>'Transparent SID'), 'rewrite'),
    'PAPAYA_SESSION_CACHE'    => array (5, 'isAlpha', 'combo', array('private'=>'private', 'nocache'=>'nocache'), 'private'),

    'PAPAYA_LAYOUT_TEMPLATES' => array (8, 'isAlphaNum', 'dircombo', array('templates/', 'upload'), 'standard-html'),
    'PAPAYA_LAYOUT_THEME'     => array (8, 'isAlphaNum', 'dircombo', array('papaya-themes/', 'page'), 'papaya-demo'),

    'PAPAYA_PAGEID_DEFAULT'   => array (9, 'isNum', 'input', '5', 1),
    'PAPAYA_PAGEID_USERDATA'  => array (9, 'isNum', 'input', '5', 0),
    'PAPAYA_PAGEID_GLOSSARY'  => array (9, 'isNum', 'input', '5', 0),
    'PAPAYA_PAGEID_ERROR_403'        => array (9, 'isNum', 'input', '5', 0),
    'PAPAYA_PAGEID_ERROR_404'        => array (9, 'isNum', 'input', '5', 0),
    'PAPAYA_PAGEID_ERROR_500'        => array (9, 'isNum', 'input', '5', 0),

    'PAPAYA_DB_TABLEPREFIX'      => array (6, 'isAlpha', 'input', 5, 'papaya'),
    'PAPAYA_PATH_ADMIN'           => array (6, 'isAlpha', 'input', 60, '/papaya'),

    'PAPAYA_LATIN1_COMPATIBILITY'  => array (10, 'isNum', 'combo', array(1=>'on',0=>'off'), 1),
    'PAPAYA_INPUT_ENCODING'  => array (10, 'isAlphaNumChar', 'combo', 
        array('utf-8'      => 'utf-8', 
              'iso-8859-1' => 'iso-8859-1'), 'utf-8'),
    'PAPAYA_DATABASE_COLLATION'  => array (10, 'isAlphaNumChar', 'combo',
        array('utf8_bin'           => 'utf8_bin', 
              'utf8_czech_ci'      => 'utf8_czech_ci', 
              'utf8_danish_ci'     => 'utf8_danish_ci',
              'utf8_estonian_ci'   => 'utf8_estonian_ci', 
              'utf8_general_ci'    => 'utf8_general_ci', 
              'utf8_icelandic_ci'  => 'utf8_icelandic_ci',
              'utf8_latvian_ci'    => 'utf8_latvian_ci', 
              'utf8_lithuanian_ci' => 'utf8_lithuanian_ci', 
              'utf8_persian_ci'    => 'utf8_persian_ci',
              'utf8_polish_ci'     => 'utf8_polish_ci', 
              'utf8_roman_ci'      => 'utf8_roman_ci', 
              'utf8_romanian_ci'   => 'utf8_romanian_ci',
              'utf8_slovak_ci'     => 'utf8_slovak_ci', 
              'utf8_slovenian_ci'  => 'utf8_slovenian_ci', 
              'utf8_spanish2_ci'   => 'utf8_spanish2_ci',
              'utf8_spanish_ci'    => 'utf8_spanish_ci', 
              'utf8_swedish_ci'    => 'utf8_swedish_ci', 
              'utf8_turkish_ci'    => 'utf8_turkish_ci',
              'utf8_unicode_ci'    => 'utf8_unicode_ci'), 'utf8_general_ci'),

    'PAPAYA_OVERVIEW_ITEMS_UNPUBLISHED' => array (11, 'isNum', 'input', 2, 15),
    'PAPAYA_OVERVIEW_ITEMS_PUBLISHED' => array (11, 'isNum', 'input', 2, 10),
    'PAPAYA_OVERVIEW_ITEMS_MESSAGES' => array (11, 'isNum', 'input', 2, 10),
    'PAPAYA_OVERVIEW_ITEMS_TASKS' => array (11, 'isNum', 'input', 2, 10),
    'PAPAYA_OVERVIEW_TASK_NOTIFY' => array (11, 'isNum', 'combo', array(1=>'on',0=>'off'), 0),
    
    'PAPAYA_LOGIN_RESTRICTION' => array(12, 'isNum', 'combo', 
      array(0 => 'None', 
            1 => 'Use Blacklist', 
            2 => 'Use Blacklist and Whitelist', 
            3 => 'Restrict to Whitelist'), 0),
    'PAPAYA_LOGIN_CHECKTIME' => array(12, 'isNum', 'input', 5, 600),
    'PAPAYA_LOGIN_NOTIFYCOUNT' => array(12, 'isNum', 'input', 5, 10),
    'PAPAYA_LOGIN_BLOCKCOUNT' => array(12, 'isNum', 'input', 5, 20),
    'PAPAYA_LOGIN_NOTIFYEMAIL'  => array (12, 'isEMail', 'input', 50, ''),
  );

  var $tables = array(
    'PAPAYA_DB_TBL_AUTHGROUPS'             => 'auth_groups',
    'PAPAYA_DB_TBL_AUTHLINK'               => 'auth_link',
    'PAPAYA_DB_TBL_AUTHPERM'               => 'auth_perm',
    'PAPAYA_DB_TBL_AUTHUSER'               => 'auth_user',
    'PAPAYA_DB_TBL_AUTHOPTIONS'            => 'auth_useropt',
    'PAPAYA_DB_TBL_AUTHMODPERMS'           => 'auth_modperm',
    'PAPAYA_DB_TBL_AUTHMODPERMLINKS'       => 'auth_modperm_link',
    'PAPAYA_DB_TBL_AUTHTRY'                => 'auth_try',
    'PAPAYA_DB_TBL_AUTHIP'                 => 'auth_ip',

    'PAPAYA_DB_TBL_BOX'                    => 'box',
    'PAPAYA_DB_TBL_BOX_PUBLIC'             => 'box_public',
    'PAPAYA_DB_TBL_BOX_VERSIONS'           => 'box_versions',
    'PAPAYA_DB_TBL_BOX_TRANS'              => 'box_trans',
    'PAPAYA_DB_TBL_BOX_PUBLIC_TRANS'       => 'box_public_trans',
    'PAPAYA_DB_TBL_BOX_VERSIONS_TRANS'     => 'box_versions_trans',

    'PAPAYA_DB_TBL_BOXGROUP'               => 'boxgroups',
    'PAPAYA_DB_TBL_BOXLINKS'               => 'boxlinks',
    'PAPAYA_DB_TBL_CRONJOBS'               => 'cronjobs',
    'PAPAYA_DB_TBL_IMAGES'                 => 'images',
    'PAPAYA_DB_TBL_LNG'                    => 'lng',
    'PAPAYA_DB_TBL_LOG'                    => 'log',
    'PAPAYA_DB_TBL_TODOS'                  => 'todos',
    'PAPAYA_DB_TBL_MEDIA_FILES'            => 'media_files',
    'PAPAYA_DB_TBL_MEDIA_FILES_TRANS'      => 'media_files_trans',
    'PAPAYA_DB_TBL_MEDIA_FOLDERS'          => 'media_folders',
    'PAPAYA_DB_TBL_MEDIA_FOLDERS_TRANS'    => 'media_folders_trans',
    'PAPAYA_DB_TBL_MESSAGES'               => 'messages',
    'PAPAYA_DB_TBL_MIMETYPES'              => 'mimetypes',
    'PAPAYA_DB_TBL_MODULES'                => 'modules',
    'PAPAYA_DB_TBL_MODULEGROUPS'           => 'modulegroups',
    'PAPAYA_DB_TBL_URLS'                   => 'urls',
    'PAPAYA_DB_TBL_PHRASE'                 => 'phrase',
    'PAPAYA_DB_TBL_PHRASE_LOG'             => 'phrase_log',
    'PAPAYA_DB_TBL_PHRASE_MODULE'          => 'phrase_module',
    'PAPAYA_DB_TBL_PHRASE_MODULE_REL'      => 'phrase_relmod',
    'PAPAYA_DB_TBL_PHRASE_TRANS'           => 'phrase_trans',
    'PAPAYA_DB_TBL_SURFER'                 => 'surfer',
    'PAPAYA_DB_TBL_SURFERGROUPS'           => 'surfergroups',
    'PAPAYA_DB_TBL_SURFERPERM'             => 'surferperm',
    'PAPAYA_DB_TBL_SURFERPERMLINK'         => 'surferlinks',

    'PAPAYA_DB_TBL_TOPICS'                 => 'topic',
    'PAPAYA_DB_TBL_TOPICS_VERSIONS'        => 'topic_versions',
    'PAPAYA_DB_TBL_TOPICS_PUBLIC'          => 'topic_public',
    'PAPAYA_DB_TBL_TOPICS_TRANS'           => 'topic_trans',
    'PAPAYA_DB_TBL_TOPICS_VERSIONS_TRANS'  => 'topic_versions_trans',
    'PAPAYA_DB_TBL_TOPICS_PUBLIC_TRANS'    => 'topic_public_trans',

    'PAPAYA_DB_TBL_VIEWS'                  => 'views',
    'PAPAYA_DB_TBL_VIEWMODES'              => 'viewmodes',
    'PAPAYA_DB_TBL_VIEWLINKS'              => 'viewlinks'
  );

  /**
  * Define database table
  *
  * @access public
  */
  function defineDatabaseTables() {
    foreach($this->tables as $optionName=>$opt) {
      if (!defined($optionName)) {
        if (isset($opt)) {
          define($optionName, PAPAYA_DB_TABLEPREFIX.'_'.$opt);
        }
      }
    }
  }

  /**
  * Load and define
  *
  * @access public
  */
  function loadAndDefine() {
    $result = FALSE;
    $sql = "SELECT opt_name, opt_value
            FROM %s";
    if ($res = $this->databaseQueryFmt($sql,array($this->tableOptions))) {
      while($row = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
        if (!defined($row['opt_name'])) {
          define($row['opt_name'], $row['opt_value']);
        }
      }
      $result = TRUE;
    }
    foreach($this->optFields as $optionName=>$opt) {
      if (!defined($optionName)) {
        if (isset($opt[4])) {
          define($optionName, $opt[4]);
        }
      }
    }
    $this->define('PAPAYA_GLOBAL_LOGOBJECT', 'PAPAYA_LOG_OBJECT');
    $this->define('PAPAYA_GLOBAL_PHRASEOBJECT', 'PAPAYA_PHRASE_TRANSLATOR');

    $this->define('PAPAYA_MODULES_PATH', PAPAYA_INCLUDE_PATH.'modules/');

    $this->define('PAPAYA_PATH_CACHE', PAPAYA_PATH_DATA.'cache/');
    $this->define('PAPAYA_PATH_MEDIAFILES', PAPAYA_PATH_DATA.'media_db/');
    $this->define('PAPAYA_PATH_THUMBFILES', PAPAYA_PATH_DATA.'media_thumbs/');

    $this->define('PAPAYA_PATH_TEMPLATES', PAPAYA_PATH_DATA.'templates/'.PAPAYA_LAYOUT_TEMPLATES.'/');

    $path = str_replace('//', '/', PAPAYA_PATH_WEB.PAPAYA_PATH_ADMIN.'/');
    $this->define('PAPAYA_PATHWEB_ADMIN', $path);

    $this->defineDatabaseTables();

    return $result;
  }

  function define($name, $value) {
    if (!defined($name)) {
      define($name, $value);
    }
  }
}
?>
