<?php
/**
* Show published pages
*
* @author Thomas Weinert <weinert@papaya-cms.com>
* @package papaya
* @version $Id: papaya_publictopic.php,v 1.11 2006/01/27 13:34:48 weinert Exp $
*/


/**
* Basic class papaya_topic
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_topic.php');
/**
* Show published pages
*
* @author Thomas Weinert <weinert@papaya-cms.com>
* @package papaya
*/
class papaya_publictopic extends base_topic {
  var $tableTopics = PAPAYA_DB_TBL_TOPICS_PUBLIC;
  var $tableTopicsTrans = PAPAYA_DB_TBL_TOPICS_PUBLIC_TRANS;
  var $maxVersions = PAPAYA_VERSIONS_MAXCOUNT;

  function checkPublishPeriod($topicId) {
    require_once(PAPAYA_INCLUDE_PATH.'system/sys_base_db.php');
    $db = new base_db;
    $sql = 'SELECT published_from, published_to
              FROM %s
             WHERE topic_id= %d';
             
    $publishedObj = $db->databaseQueryFmt($sql, array($this->tableTopicsPublic, $topicId), 1);
    $row = $publishedObj->fetchRow(DB_FETCHMODE_ASSOC);
    
    if($row['published_from'] == $row['published_to']) {
      return true;
    } else {
      if(time() < $row['published_from']  || time() > $row['published_to']) {
        return false;
      } else {
        return true;
      }
    }
  }
  
  function loadOutput($topicId, $lngIdent, $versionTime = 0) {    
    if (is_integer($lngIdent) && $lngIdent > 0) {
      $lngId = (int)$lngIdent;    
    } elseif (!($lngId = $this->languageIdentToId($lngIdent))) {
      $lngId = 0;
    }
    if (parent::loadOutput($topicId, $lngId)) {
      $contentLoaded = false;
      //try to load given language
      if ($lngId > 0) {
        //check for a translation in the current language
        $contentLoaded = $this->loadTranslatedData($topicId, $lngId);
      }
      //try to load topic default language
      if ((!$contentLoaded) && $lngId <> $this->topic['topic_mainlanguage'] && $this->topic['topic_mainlanguage'] > 0) {
        $contentLoaded = $this->loadTranslatedData($topicId, $this->topic['topic_mainlanguage']);
      }
      //try to load system default language
      if ((!$contentLoaded) && defined('PAPAYA_CONTENT_LANGUAGE') && PAPAYA_CONTENT_LANGUAGE > 0) {
        $contentLoaded = $this->loadTranslatedData($topicId, PAPAYA_CONTENT_LANGUAGE);
      }
      if ($contentLoaded) {
        return true;
      }
    }
    return false;
  }

  function loadTranslatedData($id, $lng) {
    $result = FALSE;
    $sql = "SELECT t.topic_id, t.topic_title, t.topic_content, t.lng_id,
                    t.topic_trans_created, t.topic_trans_modified,
                    t.meta_title, t.meta_keywords, t.meta_descr,
                    t.view_id, v.view_title,
                    m.module_guid , m.module_title, m.module_path, m.module_file, m.module_class,
                    u.user_id, u.username, u.givenname, u.surname, u.group_id
              FROM %s AS t
              LEFT OUTER JOIN %s AS u ON t.author_id = u.user_id
              LEFT OUTER JOIN %s AS v ON v.view_id = t.view_id
              LEFT OUTER JOIN %s AS m ON m.module_guid = v.module_guid
              WHERE t.topic_id = %d AND t.lng_id = %d";
    $params = array($this->tableTopicsPublicTrans, $this->tableAuthUser, $this->tableViews, $this->tableModules, $id, $lng);
    if ($res = $this->databaseQueryFmt($sql, $params)) {
      if ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
        $this->topic['TRANSLATION'] = $row;
        $this->loadCurrentLanguage($row['lng_id']);
        $result = TRUE;
      }
      $res->free();
    }
    return $result;
  }
}
?>