<?php
/**
* Load / Save page (n-dimensional)
*
* @author Thomas Weinert <weinert@papaya-cms.com>
* @package papaya
* @version $Id: papaya_topic.php,v 1.9 2006/01/27 14:13:21 weinert Exp $

*/


/**
* Basisklasse base_topic_edit
*/
require_once(PAPAYA_INCLUDE_PATH.'system/base_topic_edit.php');
/**
* Load / Save page (n-dimensional)
*
* @author Thomas Weinert <weinert@papaya-cms.com>
* @package papaya

*/
class papaya_topic extends base_topic_edit {
  var $maxVersions = PAPAYA_VERSIONS_MAXCOUNT;

  
  function checkPublishPeriod($topicId) {
    return true;
  }

  function loadOutput($topicId, $lngIdent, $versionTime = 0) {       
    if (is_integer($lngIdent) && $lngIdent > 0) {
      $lngId = (int)$lngIdent;    
    } elseif (!($lngId = $this->languageIdentToId($lngIdent))) {
      $lngId = 0;
    }
    if (parent::loadOutput($topicId, $lngId)) {
      if ($versionTime > 0) {
        if ($this->loadVersion(0, $topicId, $versionTime)) {
          //load selected language
          $contentLoaded = $this->loadVersionTranslatedData($this->savedVersion['version_id'], $lngId);
          //load topic main language
          if ((!$contentLoaded) && $lngId <>
              $this->savedVersion['topic_mainlanguage'] && $this->savedVersion['topic_mainlanguage'] > 0) {
            $contentLoaded = $this->loadVersionTranslatedData($this->savedVersion['version_id'],
              $this->savedVersion['topic_mainlanguage']);
          }
          //load default content language
          if ((!$contentLoaded) && defined('PAPAYA_CONTENT_LANGUAGE') && PAPAYA_CONTENT_LANGUAGE > 0) {
            $contentLoaded = $this->loadVersionTranslatedData($this->savedVersion['version_id'], PAPAYA_CONTENT_LANGUAGE);
          }
          if ($contentLoaded) {
            $this->topic = $this->savedVersion;
            return TRUE;
          } else {
            return FALSE;
          }
        } else {
          return FALSE;
        }
      }
      $contentLoaded = isset($this->topic['TRANSLATION']);

      //try to load topic default language
      if ((!$contentLoaded) && $lngId <> $this->topic['topic_mainlanguage'] && $this->topic['topic_mainlanguage'] > 0) {
        $contentLoaded = $this->loadTranslatedData($topicId, $this->topic['topic_mainlanguage']);
      }
      //try to load system default language
      if ((!$contentLoaded) && defined('PAPAYA_CONTENT_LANGUAGE') && PAPAYA_CONTENT_LANGUAGE > 0) {
        $contentLoaded = $this->loadTranslatedData($topicId, PAPAYA_CONTENT_LANGUAGE);
      }
      if ($contentLoaded) {
        return TRUE;
      }
    }
    return FALSE;
  }
}
?>