<?php
/**
* Cronjobs ausfhren
* @module papaya-admin
* @author Thomas Weinert <weinert@papaya-cms.de>
* @version $Id: cronexec.php,v 1.6 2006/05/31 10:10:48 rekowski Exp $
*/

if (php_sapi_name() != 'cli') {
  header('Content-Type: text/plain');
}

$browser = FALSE;
$path = str_replace('\\', '/', dirname(dirname(__FILE__)));

if (isset($_SERVER['argv']) && isset($_SERVER['argv']) &&
    is_array($_SERVER['argv']) && count($_SERVER['argv']) > 0) {
  //called from cmdline - check for path param
  foreach($_SERVER['argv'] as $param) {
    if (FALSE !== strpos('--path=', $param)) {
      $path = str_replace('\\', '/', substr($_SERVER['argv']['path'], 7));
      break;
    }
  }
} elseif (isset($_SERVER['SCRIPT_FILENAME']) && file_exists($_SERVER['SCRIPT_FILENAME'])) {
  //called from webbrowser
  $path = str_replace('\\', '/', dirname(dirname($_SERVER['SCRIPT_FILENAME'])));
  $browser = TRUE;
}
//trailing slash
if (substr($path, -1) != '/') {
  $path .= '/';
}
if (file_exists($path) && is_dir($path) && is_file($path.'/conf.inc.php')) {
  define('PAPAYA_DOCUMENT_ROOT', $path);
  echo 'Using path: '.htmlspecialchars(PAPAYA_DOCUMENT_ROOT)."\n";
} else {
  echo 'Can not use path: '.htmlspecialchars($path.'/')."\n";
  exit;
}


/**
* Konfiguration
*/
require_once(dirname(__FILE__)."/inc.conf.php");

/**
* Optionen
*/
require_once(PAPAYA_INCLUDE_PATH.'system/papaya_options.php');
$PAPAYA_OPTIONS = &new papaya_options;
$PAPAYA_OPTIONS->loadAndDefine();

if ($browser) {
  if (defined('PAPAYA_BROWSER_CRONJOBS') && defined('PAPAYA_BROWSER_CRONJOBS_IP') &&
      PAPAYA_BROWSER_CRONJOBS) {
    if (PAPAYA_BROWSER_CRONJOBS_IP == '0.0.0.0' ||
        PAPAYA_BROWSER_CRONJOBS_IP == @$_SERVER['REMOTE_ADDR']) {
      echo 'Called from: '.htmlspecialchars(@$_SERVER['REMOTE_ADDR'])."\n";
    } else {
      echo 'Invalid access from: '.htmlspecialchars(@$_SERVER['REMOTE_ADDR'])."\n";
      exit;
    }
  } else {
    echo 'Invalid access'."\n";
    exit;
  }
}

if (defined('DEBUG_LOGOBJECT') && (trim(DEBUG_LOGOBJECT) != '')) {
  require_once(PAPAYA_INCLUDE_PATH.'system/base_log.php');
  $GLOBALS[DEBUG_LOGOBJECT] = &new base_log();
}

require_once(PAPAYA_INCLUDE_PATH.'system/sys_session.php');
require_once(PAPAYA_INCLUDE_PATH.'system/sys_pidfile.php');

echo "Start.\n";
$pid = &new pidfile(dirname(__FILE__).'/cron.pid');
if ($pid->execute()) {
  $PAPAYA_SESSION = &new rewrite_session('', FALSE, 'rewrite');
  include_once(PAPAYA_INCLUDE_PATH.'system/base_cron.php');

  $cron = &new base_cronjobs;
  if ($cronjobId = $cron->getNext()) {
    $result = $cron->executeJob($cronjobId);
  }
  echo "End.\n";
  $pid->delete();
  return 0;
} else {
  echo "Second Instance. Stop.\n";
  return 1;
}

?>