<?php
/**
* Login-Include
* @module papaya-admin
* @author Thomas Weinert <weinert@papaya-cms.de>
* @version $Id: inc.auth.php,v 1.5 2006/04/28 13:42:24 weinert Exp $
*/

error_reporting(2047);

define('PAPAYA_ADMIN_PAGE', TRUE);

require_once("./inc.conf.php");
require_once("./inc.version.php");
require_once("./inc.func.php");
require_once('./inc.glyphs.php');

includeOrRedirect(PAPAYA_INCLUDE_PATH.'system/sys_session.php');

includeOrRedirect(PAPAYA_INCLUDE_PATH.'system/papaya_options.php');

$PAPAYA_OPTIONS = &new papaya_options();

if (!$PAPAYA_OPTIONS->loadAndDefine()) {
  if (defined('PAPAYA_DBG_DATABASE_ERROR') && PAPAYA_DBG_DATABASE_ERROR) {
    redirectToInstaller();
  }
}

if (defined('PAPAYA_DBG_PHP_ERROR')) {
  error_reporting(PAPAYA_DBG_PHP_ERROR);
}


include_once(PAPAYA_INCLUDE_PATH.'system/base_auth.php');
include_once(PAPAYA_INCLUDE_PATH.'system/papaya_xsl.php');
include_once(PAPAYA_INCLUDE_PATH.'system/papaya_errors.php');

if (defined('PAPAYA_GLOBAL_LOGOBJECT') && (trim(PAPAYA_GLOBAL_LOGOBJECT) != '')) {
  include_once(PAPAYA_INCLUDE_PATH.'system/base_log.php');
  $GLOBALS[PAPAYA_GLOBAL_LOGOBJECT] = &new base_log();
}

$PAPAYA_SESSION = &new rewrite_session('', TRUE, 'rewrite');

$PAPAYA_USER = &new base_auth();
$PAPAYA_MSG = &new papaya_errors();

if (defined('PAPAYA_GLOBAL_PHRASEOBJECT') && (trim(PAPAYA_GLOBAL_PHRASEOBJECT) != '')) {
  include_once(PAPAYA_INCLUDE_PATH.'system/sys_phrases.php');
  $GLOBALS[PAPAYA_GLOBAL_PHRASEOBJECT] = &new base_phrases();
  $GLOBALS[PAPAYA_GLOBAL_PHRASEOBJECT]->getLngId(PAPAYA_UI_LANGUAGE);
}

if (isset($GLOBALS[PAPAYA_GLOBAL_LOGOBJECT]) && is_object($GLOBALS[PAPAYA_GLOBAL_LOGOBJECT])) {
  if (defined('PAPAYA_PATH_DATA') && PAPAYA_PATH_DATA != '' &&
      strpos(PAPAYA_PATH_DATA, $_SERVER['DOCUMENT_ROOT']) !== FALSE &&
      file_exists(PAPAYA_PATH_DATA) && (!file_exists(PAPAYA_PATH_DATA.'.htaccess'))) {
    $PAPAYA_MSG->add(MSG_WARNING, _gt('Please secure the upload path.'));
  }
}

$PAPAYA_LAYOUT = &new papaya_xsl(dirname(__FILE__)."/xsl/style.xsl");

$PAPAYA_USER->layout = &$PAPAYA_LAYOUT;
$PAPAYA_USER->images = &$PAPAYA_IMAGES;
$PAPAYA_USER->msgs = &$PAPAYA_MSG;

$PAPAYA_USER->initialize();
$PAPAYA_SHOW_ADMIN_PAGE = $PAPAYA_USER->execLogin();
$PAPAYA_LAYOUT->setParam('PAPAYA_LOGINPAGE', $PAPAYA_SHOW_ADMIN_PAGE ? '0' : '1');

$PAPAYA_OPTIONS->activateTheme(dirname(__FILE__), @$PAPAYA_USER->options['PAPAYA_UI_THEME']);

$PAPAYA_LAYOUT->setParam('PAGE_PROJECT', defined('PAPAYA_PROJECT_TITLE') ? PAPAYA_PROJECT_TITLE : '');

$PAPAYA_LAYOUT->setParam('PAPAYA_BGCOLOR', PAPAYA_BGCOLOR);
$PAPAYA_LAYOUT->setParam('PAPAYA_BGCOLOR_LIGHT', PAPAYA_BGCOLOR_LIGHT);
$PAPAYA_LAYOUT->setParam('PAPAYA_BGCOLOR_DARKER', PAPAYA_BGCOLOR_DARKER);
$PAPAYA_LAYOUT->setParam('PAPAYA_BGCOLOR_DARK', PAPAYA_BGCOLOR_DARK);
$PAPAYA_LAYOUT->setParam('PAPAYA_FGCOLOR', PAPAYA_FGCOLOR);
$PAPAYA_LAYOUT->setParam('PAPAYA_WINDOWCOLOR', PAPAYA_WINDOWCOLOR);
$PAPAYA_LAYOUT->setParam('PAPAYA_HIGHLIGHT_COLOR', PAPAYA_HIGHLIGHT_COLOR);
$PAPAYA_LAYOUT->setParam('PAPAYA_HIGHLIGHT_TEXTCOLOR', PAPAYA_HIGHLIGHT_TEXTCOLOR);
$PAPAYA_LAYOUT->setParam('PAPAYA_SYSTEMPICS_PATH', PAPAYA_SYSTEMPICS_PATH);


$useRichtext = $PAPAYA_SESSION->getValue('PAPAYA_SESS_USE_RICHTEXT');
$useRichtext = (isset($useRichtext)) ? (bool)$useRichtext : TRUE;
$PAPAYA_LAYOUT->setParam('PAPAYA_USE_RICHTEXT', (@(bool)$PAPAYA_USER->options['PAPAYA_USE_RICHTEXT'] && $useRichtext));

if (defined('PAPAYA_GLOBAL_PHRASEOBJECT') && (trim(PAPAYA_GLOBAL_PHRASEOBJECT) != '') &&
    isset($GLOBALS[PAPAYA_GLOBAL_PHRASEOBJECT]) &&
    PAPAYA_UI_LANGUAGE != @$PAPAYA_USER->options['PAPAYA_UI_LANGUAGE']) {
  //user has a different ui language reset object
  unset($GLOBALS[PAPAYA_GLOBAL_PHRASEOBJECT]);
  $GLOBALS[PAPAYA_GLOBAL_PHRASEOBJECT] = &new base_phrases();
  $GLOBALS[PAPAYA_GLOBAL_PHRASEOBJECT]->getLngId(@$PAPAYA_USER->options['PAPAYA_UI_LANGUAGE']);
}

if ($PAPAYA_SHOW_ADMIN_PAGE) {
  $PAPAYA_LAYOUT->setParam('PAGE_USER', $PAPAYA_USER->user['fullname']);
} else {
  $PAPAYA_LAYOUT->setParam('PAGE_USER', _gt('unknown'));
}

header('Content-type: text/html; charset=utf-8');
?>