<?php
/**
* Admin-Funktionen
* @module papaya-admin
* @author Thomas Weinert <weinert@papaya-cms.de>
* @version $Id: inc.func.php,v 1.1.1.1 2005/09/30 15:51:03 weinert Exp $
*/

/**
* Phrase bersetzen
*
* @param $phrase
* @param mixed $module optional, default value NULL
* @access public
* @return string
*/
function _gt($phrase, $module=NULL) {
  if (@is_object($GLOBALS[PAPAYA_GLOBAL_PHRASEOBJECT])) {
    return $GLOBALS[PAPAYA_GLOBAL_PHRASEOBJECT]->getText($phrase, $module);
  }
  return $phrase;
}

/**
* Text aus Datei laden
*
* @param $fileName
* @access public
* @return string
*/
function _gtfile($fileName) {
  if (isset($GLOBALS['PAPAYA_USER'])) {
    $fileName = dirname(__FILE__).'/data/'.$GLOBALS['PAPAYA_USER']->options['PAPAYA_UI_LANGUAGE'].'/'.$fileName;
  } else {
    $fileName = dirname(__FILE__).'/data/'.PAPAYA_UI_LANGUAGE.'/'.$fileName;
  }
  if ($fileName) {
    if ($fh = @fopen($fileName, 'r')) {
      $data = fread($fh, filesize($fileName));
      fclose($fh);
      return $data;
    }
  }
  return '';
}

function includeOrRedirect($includeFile) {
  if (defined('PAPAYA_DBG_DEVMODE') && PAPAYA_DBG_DEVMODE) {
    $found = @include_once($includeFile);
  } else {
    $found = include_once($includeFile);
  }
  if (!$found) {
    redirectToInstaller();
  }
}

function redirectToInstaller() {
  $protocol = (@$_SERVER['HTTPS'] == 'on') ? 'https' : 'http';
  $url = strtr($protocol.'://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).'papaya/install.php', '\\', '/');
  header('Location: '.$url);
  exit;
}

function initNavigation() {
  include_once(PAPAYA_INCLUDE_PATH.'system/papaya_navigation.php');
  $GLOBALS['PAPAYA_NAVIGATION'] = &new papaya_navigation();
  $GLOBALS['PAPAYA_NAVIGATION']->authUser = &$GLOBALS['PAPAYA_USER'];
  $GLOBALS['PAPAYA_NAVIGATION']->layout = &$GLOBALS['PAPAYA_LAYOUT'];
  $GLOBALS['PAPAYA_NAVIGATION']->initialize();
}

?>